// AjustDlg.h : header file
//________________________________________
#include "HalconCPP.h"
// CAjustDlg dialog
class CAjustDlg : public CDialog
{
// Construction
public:
	CAjustDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CAjustDlg)
	enum { IDD = IDD_AJUST };
	CSliderCtrl	m_sliderI;
	CSliderCtrl	m_sliderG;
	CString	m_sG;
	CString	m_sI;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAjustDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc *m_pDoc;
	class CBkApp *m_pApp;
	class CBkView *m_pView;
	short 
		m_iIt;
	unsigned char 
		*w_R,*w_G,*w_B;
	long m_channels,m_L,m_H;
	Hobject imageOri;
	float m_fGt;
	BOOL m_OK;
	short m_iNb;

	void GetPixelColor(Hobject image,unsigned char *wR,unsigned char *wG,unsigned char *wB);
	void SetPixelColor(long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB,Hobject *image);
	void GetSize(Hobject image,long *L,long *H,long *channels);
	void Visualiser();

	void gammabrighten(float gamma,long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB);
	void changebright(short w,long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB);


	// Generated message map functions
	//{{AFX_MSG(CAjustDlg)
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnOri();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
