// Code.h : header file
//Halcon
#include "HalconCPP.h"
//________________________________________
// CCode window
class CCode : public CWnd
{
// Construction
public:
	CCode(CBkDoc *pDoc);

// Attributes
public:

protected:
	CBkDoc *m_pDoc;
	//Codes de 1  9 en fonction des digits (tableau 1 sujet)
	short C[10][3];
	//Types pour codes de 1  6
	CString m_sType[10];
	unsigned long 
		m_lCb,
		m_lCf;
	short 
		m_iTrait,	//Epaisseur en pixel du trait simple
		m_iBlanc,	//Epaisseur en pixel de l'espace simple
		m_iLarg,m_iHaut;

	unsigned char 
		*m_R,*m_G,*m_B;
	short m_iL,m_iH;

// Operations
public:
	void TraceCode(short x,short y,CString Code);
	void Couleur(long B,long E);

protected:
	void Affectation(void);
	void CodeRef(char Pos,short x,short y);
	void CodeChiffre(short Chiffre,short No,char Digit,short x,short y);
	void Rectangle(short xd,short yd,short xa,short ya,long coul);
	void get_pixelcolor(Hobject image,short l,short h,unsigned char *w_R,unsigned char *w_V,unsigned char *w_B);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCode)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCode();

	// Generated message map functions
protected:
	//{{AFX_MSG(CCode)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
