// ConRsDlg.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "ConRsDlg.h"
#include "BkView.h"
#include "BkDoc.h"
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CConRsDlg dialog
CConRsDlg::CConRsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConRsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConRsDlg)
	m_sTexte2 = _T("");
	m_sTexte1 = _T("");
	//}}AFX_DATA_INIT
	Create(IDD_CONNEXION,pParent);
}
void CConRsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConRsDlg)
	DDX_Text(pDX, IDC_STATIC2, m_sTexte2);
	DDX_Text(pDX, IDC_EDIT1, m_sTexte1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CConRsDlg, CDialog)
	//{{AFX_MSG_MAP(CConRsDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CConRsDlg message handlers
void CConRsDlg::PostNcDestroy()
{
	delete this;
}
//________________________________________
BOOL CConRsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	setlocale(LC_TIME,"French");
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_OK=FALSE;
	m_sTexte2.Format("");
	m_sTexte1="";
	UpdateData(FALSE);	
	return TRUE;
}
//________________________________________
void CConRsDlg::Fermer(void)
{
	KillTimer(99);
	CloseHandle(m_hCom);
	CDialog::OnCancel();
}
//________________________________________
BOOL CConRsDlg::WriteCom(CString s)
{
	DWORD i;
	BOOL ok;
	if (m_hCom!=INVALID_HANDLE_VALUE)
	{
		ok=WriteFile(m_hCom,s,s.GetLength(),&i,NULL);
	}
	else
		ok=FALSE;
	return ok;
}
//________________________________________
void CConRsDlg::OnTimer(UINT nIDEvent) 
{
	CString s,s1;
	short i,j,k;
	BOOL ok=FALSE;
	//Rception sur port srie
	if (m_OKBusy==FALSE)
	{
		m_OKBusy=TRUE;
		ok=ReadCom();
		m_t2=CTime::GetCurrentTime();
		CTimeSpan t=m_t2-m_t1;
		s=t.Format("%H:%M:%S");
		m_sTexte2.Format("Connect  COM%d:9600,8,'N',1 depuis %s\nLe buffer contient %d caractre(s).",m_radioCom+1,s,m_pBuf->GetLength());
		if (m_pBuf->GetLength()>14000)
		{
			s=m_pBuf->Right(20);
			*m_pBuf=s;
			m_sTexte2.Format("Initialisation buffer ...");
			Sleep(200);
		}
		UpdateData(FALSE);
		m_OKBusy=FALSE;
	}	
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
HANDLE CConRsDlg::Connexion(int radioCom,CString *buffer) 
{
	DCB dcb;
	BOOL ok;

	m_pBuf=buffer;
	m_radioCom=radioCom;
	switch (m_radioCom)
	{
		case 0://COM1
			m_hCom=CreateFile("COM1",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
		case 1://COM2
			m_hCom=CreateFile("COM2",GENERIC_READ|GENERIC_WRITE,0,NULL,OPEN_EXISTING,0,NULL);
		break;
	}
	if (m_hCom==INVALID_HANDLE_VALUE)
	{
		m_sTexte2.Format("Erreur de connexion au port COM%d !",m_radioCom+1);
		UpdateData(FALSE);	
	}
	else
	{
			GetCommState(m_hCom,&dcb);
			//Paramtres du port srie
			//9600,8,'N',1
			dcb.BaudRate=CBR_9600;	//9600 bauds
			dcb.ByteSize=8;					//8 bits
			dcb.StopBits=ONESTOPBIT;//ONESTOPBIT;//1 bit stop
			dcb.fParity=1;					//Enable parity checking
			dcb.Parity=0;						//0:no, 1:odd, 2:even, 3:mark, 4:space

		//Dans StdAfx.h:
		//#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers
		SetCommState(m_hCom,&dcb);
		COMMTIMEOUTS ctmo;
		ok=GetCommTimeouts(m_hCom,&ctmo);
		if (ok)
		{
			ctmo.ReadIntervalTimeout=MAXDWORD;
			ctmo.ReadTotalTimeoutMultiplier=0;
			ctmo.ReadTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutConstant=0;
			ctmo.WriteTotalTimeoutMultiplier=0;
			SetCommTimeouts(m_hCom,&ctmo);
		}
		m_t1=CTime::GetCurrentTime();   
		m_OKBusy=FALSE;SetTimer(99,1,NULL);
	}
	return m_hCom;
}
//________________________________________
BOOL CConRsDlg::ReadCom(void)
{
	//Les caractres retourns sont dans le buffer m_sBuf
	BOOL ok,ok1=FALSE;
	DWORD i,j;
	char c[1];
	do
	{
		ok=ReadFile(m_hCom,c,1,&j,NULL);
		if (ok && j!=0)
		{
			if (c[0]!='\n' && c[0]!='\r') 
				m_sTexte1=m_sTexte1+c[0];
			else
				m_sTexte1=m_sTexte1+"  ";
			if (m_sTexte1.GetLength()>140)	m_sTexte1="... "+m_sTexte1.Right(140);
			//Affectation au buffer
			*m_pBuf=*m_pBuf+c[0];
			ok1=TRUE;
		}
	}
	while (ok && j);
	return ok1;
}
