/*****************************************************************************
 * HDeclSpec.h
 ***************************************************************************** 
 *
 * Project:     Halcon/libhalcon
 * Description: Windows NT DLL specifications
 *
 * (c) 1996-98 by MVTec Software GmbH
 *                Orleansstr. 34, 81667 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.13 $
 * $Date: 2000/02/24 15:00:39 $
 *
 */


#ifndef HALCON_DECL_SPEC_H
#define HALCON_DECL_SPEC_H

#if defined(WIN32) && !defined (_NODLL)
#if defined(_HLibDLL)
#define HLibExport __declspec(dllexport)
#else
#define HLibExport __declspec(dllimport)
#endif
#if defined(_LIntDLL)
#define LIntExport __declspec(dllexport)
#else
#define LIntExport __declspec(dllimport)
#endif
#define HUserExport  __declspec(dllexport)
#define HUserImport __declspec(dllimport)
#else /* not WIN32 */
#define HLibExport 
#define LIntExport 
#define HUserExport 
#define HUserImport
#endif /* not WIN32 */

#endif
