// MathLogDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "MathLogDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMathLogDlg dialog
CMathLogDlg::CMathLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMathLogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMathLogDlg)
	m_s8 = _T("");
	m_radioOp = -1;
	m_s15 = _T("");
	//}}AFX_DATA_INIT
}
//________________________________________
void CMathLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMathLogDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Control(pDX, IDC_SOURCE2, m_comboSource2);
	DDX_Control(pDX, IDC_SOURCE, m_comboSource);
	DDX_Text(pDX, IDC_STATIC8, m_s8);
	DDX_Radio(pDX, IDC_OP1, m_radioOp);
	DDX_Text(pDX, IDC_STATIC15, m_s15);
	//}}AFX_DATA_MAP
}
//________________________________________
BEGIN_MESSAGE_MAP(CMathLogDlg, CDialog)
	//{{AFX_MSG_MAP(CMathLogDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CMathLogDlg message handlers
BOOL CMathLogDlg::OnInitDialog() 
{
	short i;
	CString s;
	CDialog::OnInitDialog();
	m_pApp=((CBkApp*)AfxGetApp());
	m_pApp->GetDocument(m_pDoc);
	for (i=0;i<20;i++)
	{
		if (m_pDoc[i]!=NULL)
		{
			s.Format("%s",m_pDoc[i]->m_sNomFic);	
			m_comboSource.AddString(s);
			m_comboSource2.AddString(s);
		}
	}
	i=m_comboSource.GetCount()-1;if (i<0) i=0;
	m_comboSource.GetLBText(i,s);
	m_comboSource.SetWindowText(s);	
	i=m_comboSource2.GetCount()-1;if (i<0) i=0;
	m_comboSource2.GetLBText(i,s);
	m_comboSource2.SetWindowText(s);	
	m_radioOp=3;
	m_s8="NOUV. IMAGE";	
	UpdateData(FALSE);
	SetTimer(14,100,NULL);
	return TRUE;
}
//________________________________________
void CMathLogDlg::OnOK() 
{
	KillTimer(14);
	UpdateData(TRUE);
	short i,j,l,h;
	if (m_comboSource.GetCurSel()<0)
		m_ps1=m_pDoc[m_comboSource.GetCount()-1];
	else
		m_ps1=m_pDoc[m_comboSource.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		m_ps2=m_pDoc[m_comboSource2.GetCount()-1];
	else
		m_ps2=m_pDoc[m_comboSource2.GetCurSel()];

	l=m_ps1->m_iL;
	h=m_ps1->m_iH;

	CMDIChildWnd *pChild;
	SendMessage(WM_COMMAND,ID_FILE_NEW,0);
	pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	m_pd=(CBkDoc*)pChild->GetActiveDocument();
	m_pd->m_iL=l;m_pd->m_iH=h;;
	m_pd->DimensionnerFenetre(l,h);
	m_pd->DefinirCurseurs(l,h);
	set_window_extents(m_pd->m_pView->m_lWindowID,0,0,l,h);

	unsigned char 
		W,W1,W2,
		*w,*wR1,*wV1,*wB1,*wR2,*wV2,*wB2;
	long k;
	w=new unsigned char[l*h];
	wR1=new unsigned char[l*h];
	wV1=new unsigned char[l*h];
	wB1=new unsigned char[l*h];
	wR2=new unsigned char[l*h];
	wV2=new unsigned char[l*h];
	wB2=new unsigned char[l*h];

	switch (m_radioOp)
	{
		case 0://Addition
			add_image(m_ps1->image,m_ps2->image,&m_pd->image,1.0,1.0);
		break;	
		case 1://Addition modulo 256
			getpixelcolor(m_ps1->image,l,h,wR1,wV1,wB1);
			getpixelcolor(m_ps2->image,l,h,wR2,wV2,wB2);
			for (i=0;i<l;i++)
			{
				for (j=0;j<h;j++)
				{
					if (wR1[i+j*l]==wV1[i+j*l] && wR1[i+j*l]==wB1[i+j*l])
					{
						//N&B
						W1=wR1[i+j*l];
					}
					else
					{
						//Conversion en N&B
						k=(30*wR1[i+j*l]+59*wV1[i+j*l]+11*wB1[i+j*l])/100;
						W1=k;
					}
					if (wR2[i+j*l]==wV2[i+j*l] && wR2[i+j*l]==wB2[i+j*l])
					{
						W2=wR2[i+j*l];
					}
					else
					{
						//Conversion en N&B
						k=(30*wR2[i+j*l]+59*wV2[i+j*l]+11*wB2[i+j*l])/100;
						W2=k;
					}
					W=W1+W2;
					if (W>=256)
					{
						w[i+j*l]=W-256;
					}
					else
					{
						w[i+j*l]=W;
					}
				}
			}
			gen_image1(&(m_pd->image),"byte",l,h,(long)w);
		break;	
		case 2://Soustraction
			sub_image(m_ps1->image,m_ps2->image,&m_pd->image,1.0,1.0);
		break;
		case 3://Soustraction modulo 256
			getpixelcolor(m_ps1->image,l,h,wR1,wV1,wB1);
			getpixelcolor(m_ps2->image,l,h,wR2,wV2,wB2);
			for (i=0;i<l;i++)
			{
				for (j=0;j<h;j++)
				{
					if (wR1[i+j*l]==wV1[i+j*l] && wR1[i+j*l]==wB1[i+j*l])
					{
						//N&B
						W1=wR1[i+j*l];
					}
					else
					{
						//Conversion en N&B
						k=(30*wR1[i+j*l]+59*wV1[i+j*l]+11*wB1[i+j*l])/100;
						W1=k;
					}
					if (wR2[i+j*l]==wV2[i+j*l] && wR2[i+j*l]==wB2[i+j*l])
					{
						W2=wR2[i+j*l];
					}
					else
					{
						//Conversion en N&B
						k=(30*wR2[i+j*l]+59*wV2[i+j*l]+11*wB2[i+j*l])/100;
						W2=k;
					}
					W=W1-W2;
					if (W<0)
					{
						w[i+j*l]=W+256;
					}
					else
					{
						w[i+j*l]=W;
					}
				}
			}
			gen_image1(&(m_pd->image),"byte",l,h,(long)w);
		break;	
		case 4://ET
			bit_and(m_ps1->image,m_ps2->image,&m_pd->image);
		break;	
		case 5://OU
			bit_or(m_ps1->image,m_ps2->image,&m_pd->image);
		break;	
		case 6://XOR
			bit_xor(m_ps1->image,m_ps2->image,&m_pd->image);
		break;	
		case 7://Multiplication
			mult_image(m_ps1->image,m_ps2->image,&m_pd->image,1.0,1.0);
		break;	
		case 8://Division
			div_image(m_ps1->image,m_ps2->image,&m_pd->image,1.0,1.0);
		break;	
	}
	delete w;
	delete wR1;delete wV1;delete wB1;
	delete wR2;delete wV2;delete wB2;
	CDialog::OnOK();
}
//________________________________________
void CMathLogDlg::getpixelcolor(Hobject image,short l,short h,unsigned char *wR,unsigned char *wV,unsigned char *wB) 
{
	short i,j;
	long L,H,channels;
	char lpcsType[128];
	unsigned char *R,*V,*B;

	count_channels(image,&channels);
	if (channels==1) 
	{
		get_image_pointer1(image,(long*)&R,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");

		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wV[i+j*l]=*(R+i+j*l);
				wB[i+j*l]=*(R+i+j*l);
			}
		}
	}
	else
	{
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wV[i+j*l]=*(V+i+j*l);
				wB[i+j*l]=*(B+i+j*l);
			}
		}
	}
}
//________________________________________
void CMathLogDlg::OnCancel() 
{
	KillTimer(14);
	CDialog::OnCancel();
}
//________________________________________
void CMathLogDlg::OnTimer(UINT nIDEvent) 
{
	short l,h,L,H;
	long ch1,ch2;
	UpdateData(TRUE);

	if (m_comboSource.GetCurSel()<0)
		m_ps1=m_pDoc[m_comboSource.GetCount()-1];
	else
		m_ps1=m_pDoc[m_comboSource.GetCurSel()];
	if (m_comboSource2.GetCurSel()<0)
		m_ps2=m_pDoc[m_comboSource2.GetCount()-1];
	else
		m_ps2=m_pDoc[m_comboSource2.GetCurSel()];

	l=m_ps1->m_iL;
	h=m_ps1->m_iH;
	L=m_ps2->m_iL;
	H=m_ps2->m_iH;

	count_channels(m_ps2->image,&ch2);
	count_channels(m_ps1->image,&ch1);
	
	if ((m_ps1->m_iType&8)==8 || (m_ps2->m_iType&8)==8)
	{
		//FFT, ne fonctionne pas !
		m_btnOK.EnableWindow(FALSE);
		m_s15="Oprations impossibles sur images FFT !";
	}
	else
	if ((ch1!=ch2))
	{
		m_btnOK.EnableWindow(FALSE);
		m_s15="Les images sont de types diffrents !";
	}
	else
	if (l!=L || h!=H)
	{
		m_btnOK.EnableWindow(FALSE);
		m_s15="Les images sont de tailles diffrentes !";
	}
	else
	{
		m_btnOK.EnableWindow(TRUE);
		m_s15="";
	}
	UpdateData(FALSE);
	CDialog::OnTimer(nIDEvent);
}
