// MeteorBk.h : header file
#include "mil.h"
#include "mwinmil.h"
#include "milsetup.h"
#include "milerr.h"

//________________________________________
// CMeteorBk window
class CMeteorBk : public CWnd
{
// Construction
public:
	CMeteorBk();

// Attributes
public:
	long		SizeX;						// Buffer Size X
	long		SizeY;						// Buffer Size Y
	long		DigSizeX;					// Digitizer input width
	long		DigSizeY;					// Digitizer input heigh
	long		Band;				      // Number of input color bands of the digitizer
	//CView   *GrabInViewPtr;		// Pointer to the view that has the grab
	long		NumberOfDigitizer;// Number of digitizers available on the system
  MIL_ID 	MilApplication;		// Application identifier.  
  MIL_ID 	MilSystem;     		// System identifier.       
	MIL_ID 	MilDigitizer;			// Digitizer identifier.
	MIL_ID MilImage;					//Image buffer identifier.
	long BufferAttributes;		// Buffer attributes that will be allocated
	MAPPHOOKFCTPTR HandlerPtr;
	void* HandlerUserPtr;

//Prototypes______________________________
	long MFTYPE DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr);
	short TestMeteor(void);
	short InitMeteor(short *L,short *H);
	void LibereMeteor(void);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMeteorBk)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMeteorBk();

	// Generated message map functions
protected:
	//{{AFX_MSG(CMeteorBk)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
