// MultDlg.h : header file
#include "HalconCPP.h"
//________________________________________
// CMultDlg dialog
class CMultDlg : public CDialog
{
// Construction
public:
	CMultDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CMultDlg)
	enum { IDD = IDD_MULT };
	CSliderCtrl	m_slider;
	CButton	m_btnOK;
	CButton	m_btnCancel;
	CString	m_s1;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMultDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	class CBkDoc* m_pDoc;
	class CBkApp* m_pApp;
	class CBkView *m_pView;
	float m_fCoef;
	unsigned char 
		*w_R,*w_G,*w_B;
	long m_channels,m_L,m_H;
	Hobject imageOri;
	BOOL m_OK;
	short m_iNb;

	void GetPixelColor(Hobject image,unsigned char *wR,unsigned char *wG,unsigned char *wB);
	void SetPixelColor(long l,long h,unsigned char *wR,unsigned char *wG,unsigned char *wB,Hobject *image);
	void GetSize(Hobject image,long *L,long *H,long *channels);
	void Visualiser();

	// Generated message map functions
	//{{AFX_MSG(CMultDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnOri();
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
