// Bk.h : main header file for the BK application
#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"       // main symbols
//________________________________________
// CBkApp:
// See Bk.cpp for the implementation of this class
class CBkApp : public CWinApp
{
public:
	CBkApp();

	short m_iNo;			     //N de la premire image ouverte
	short m_iNb;			     //Nb. de fentres ouvertes
	short m_iL,m_iH;	     //Taille de la fentre en pixels
	short 
		m_iLfen,m_iHfen,
		m_iLmax,m_iHmax; //Taille maxi des fentres
	class CBkDoc *pDocGrab;	//Pointeur sur le document en acquisition permanente

	//Outils de dessin______________________
	CPen plume[8];
	CFont	fonteC[180];
	LOGFONT lf;
	long couleur[8];
	short m_iHaut,m_iEpais;
	//Image  copier________________________
	class CBkDoc *m_pDocACopier;
	//Numriseur connect
	short m_iCarte;//0:Aucune, 1:Twain, 2:Webcam, 3:Direct Show, 4:Meteor, 5:IEEE, 6:blueFox
	short m_iTaille;
protected:
	short m_iLH[10][2];	//Tailles numriseurs
public:
	//Camra mvBlueFox
	float m_fGain;
	short m_iShutter;

	CSize m_sizeFen;
	//Forme du tracker______________________
	short m_radioTypeTracker;
	//Botes de dialogue non modales________
	class CExtractDlg *m_pExtractDlg;
	class CCoordDlg *m_pCoordDlg;
	class CCodeHalcon *m_pCodeDlg;
	//Carte Orion
	class CMatroxOrion *m_pOrion;
	//Lecteur Leuze
	short m_radioCom;

protected:
	void DefinirOutils(void);
	void EffacerOutils(void);
	void Lire_Ecrire(CArchive& ar);
public:	
	void FermerFenetre(CBkDoc *pDoc);
	CBkDoc* CreerNouvelleFenetre(short l,short h);
	void GetDocumentSansCourant(CBkDoc *p[20]);
	void GetDocument(CBkDoc *p[20]);
	void Cascade(void);
	short Largeur_x_Hauteur(short i,short *L,short *H);
	BOOL VerifResol(short carte,short l,short h);
	void AffecteResolutions(short carte);



// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation

	//{{AFX_MSG(CBkApp)
	afx_msg void OnAppAbout();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
