// BkView.h : interface of the CBkView class
class CBkView : public CScrollView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
public:
	//Halcon
	HDC m_hdcHalconDC;
	long m_lWindowID,m_lWindowID1;

protected:
	class CBkApp* m_pApp;
	BOOL m_OK;
// Operations
public:
	CBkDoc* GetDocument();
	void GrabArret();
	void GrabContinu(class CBkDoc *pDoc);
	void VisuHalcon(void);

	HWND m_HWND;

protected:
	//Menu contextuel
	void InitSouris(void);
	void InitProfils(void);
	void Grab(void);
	void StopGrab(void);
	//______________________________________
	void MarqueDePointage(CDC *pDC,short x,short y,short NoPlume,BOOL OK);
	void MAJ_Fen();
	void OnTrace(CDC* pDC);
	void ProfilV(CDC *pDC);
	void ProfilH(CDC *pDC);
	void GaussH(CDC *pDC);
	void GaussV(CDC *pDC);
	void SegmentProfil(CDC *pDC);
	void TraceTracker(CDC *pDC,char Type);
	void GestionCurseurSouris(short x,short y);


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual void OnPrint(CDC* pDC,CPrintInfo * pInfo);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType = adjustBorder);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
// Generated message map functions
protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BkView.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*)m_pDocument; }
#endif
//________________________________________
