// ExcelBk.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "ExcelBk.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CExcelBk
CExcelBk::CExcelBk()
{
	//Exportation vers Excel...
	//IMPORTANT: Voir Bk.cpp et stdafx.h
	m_pAppli=new _Application();
}
CExcelBk::~CExcelBk()
{
	m_pAppli->Quit();
	delete m_pAppli;
}
//________________________________________
BEGIN_MESSAGE_MAP(CExcelBk, CWnd)
	//{{AFX_MSG_MAP(CExcelBk)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CExcelBk message handlers
void CExcelBk::EcritureExcel(CBkDoc *pDoc) 
{
	BOOL OKGaussH,OKProfilH,OKGaussV,OKProfilV;
	OKGaussH=FALSE;
	OKProfilH=FALSE;
	OKGaussV=FALSE;
	OKProfilV=FALSE;

	if (pDoc!=NULL)
	{
		//pDoc->CalculProfils(pDoc->m_p.radioComposante,pDoc->m_p.iX1,pDoc->m_p.iY1,pDoc->m_p.iX2,pDoc->m_p.iY2);
		if(abs(pDoc->m_p.iX1-pDoc->m_p.iX2)>10)
		{
			OKProfilH=TRUE;
			if (pDoc->m_OKGauss) OKGaussH=TRUE;
			//CString z;z.Format("%d,%d",pDoc->m_p.iX1,pDoc->m_p.iX2);
			//AfxMessageBox(z);
		}
		if (abs(pDoc->m_p.iY1-pDoc->m_p.iY2)>10)
		{
			OKProfilV=TRUE;
			if (pDoc->m_OKGauss) OKGaussV=TRUE;
		}

		//CString z;z.Format("%d,%d,%d,%d",OKProfilH,OKProfilV,OKGaussH,OKGaussV);AfxMessageBox(z);

		CString s1,s2,s3,s4,s5,s6;
		Range range,range1,range2,range3,range4,range5,range6;
		Workbooks books;
		_Workbook book;
		Worksheets sheets;
		_Worksheet sheet;

		COleVariant 
			covTrue((short)TRUE),
			covFalse((short)FALSE),
			covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
		if (!m_pAppli->CreateDispatch("Excel.Application"))
		{
			AfxMessageBox("Erreur de dmarrage Excel");
		}
		else
		{
			//m_pAppli->SetVisible(TRUE);
			m_pAppli->SetVisible(FALSE);

			books=m_pAppli->GetWorkbooks();
			book=books.Add(covOptional); 
			sheets=m_pAppli->GetSheets();
			//m_pAppli->SetSheetsInNewWorkbook(1);
			sheet=sheets.GetItem(COleVariant((short)1));
			sheet.SetName("Profil(s)");

			range=sheet.GetRange(COleVariant("A1"),COleVariant("A1"));
			range.SetValue(COleVariant("LOGICIEL ..."));

			range1=sheet.GetRange(COleVariant("A2"),COleVariant("A2"));
			range2=sheet.GetRange(COleVariant("B2"),COleVariant("B2"));
			range3=sheet.GetRange(COleVariant("C2"),COleVariant("C2"));
			range4=sheet.GetRange(COleVariant("D2"),COleVariant("D2"));
			range5=sheet.GetRange(COleVariant("E2"),COleVariant("E2"));
			range6=sheet.GetRange(COleVariant("F2"),COleVariant("F2"));

			s1=s2=s3=s4=s5=s6="";
			//Units
			if (pDoc->m_OKXY)
			{


				if (OKProfilH || OKGaussH) s1="x(mm)";
				if (OKProfilV || OKGaussV) s4="y(mm)";
			}
			else
			{
				if (OKProfilH || OKGaussH) s1="iH(pixel)";
				if (OKProfilV || OKGaussV) s4="jV(pixel)";
			}

			//Units
			if (OKProfilH) s2="wH(luminance)";
			if (OKGaussH) s3="GaussH";
			if (OKProfilV) s5="wV(luminance)";
			if (OKGaussV) s6="GaussV";
			range1.SetValue(COleVariant(s1));
			range2.SetValue(COleVariant(s2));
			range3.SetValue(COleVariant(s3));
			range4.SetValue(COleVariant(s4));
			range5.SetValue(COleVariant(s5));
			range6.SetValue(COleVariant(s6));
			short i,nb;
			i=3;
			for (nb=0;nb<=pDoc->m_iNb;nb++)
			{
				s1.Format("A%u",i);
				range1=sheet.GetRange(COleVariant(s1),COleVariant(s1));
				s2.Format("B%u",i);
				range2=sheet.GetRange(COleVariant(s2),COleVariant(s2));
				s3.Format("C%u",i);
				range3=sheet.GetRange(COleVariant(s3),COleVariant(s3));
				s4.Format("D%u",i);
				range4=sheet.GetRange(COleVariant(s4),COleVariant(s4));
				s5.Format("E%u",i);
				range5=sheet.GetRange(COleVariant(s5),COleVariant(s5));
				s6.Format("F%u",i);
				range6=sheet.GetRange(COleVariant(s6),COleVariant(s6));
				//m_fT[0]:iH, [1]:wH,[2]:GaussH, [3]:wV, [4]:jV, [5]:GaussV
				s1=s2=s3=s4=s5=s6="";
				if (pDoc->m_OKXY)
				{
					//mm
					if (pDoc->m_fT[nb][0]!=1e10 && OKProfilH) s1.Format("%1.3e",pDoc->m_fT[nb][0]/pDoc->m_fEchXY);//xmm
					if (pDoc->m_fT[nb][4]!=1e10 && OKProfilV) s4.Format("%1.3e",pDoc->m_fT[nb][4]/pDoc->m_fEchXY);//ymm
				}
				else
				{
					//pixel
					if (pDoc->m_fT[nb][0]!=1e10 && OKProfilH) s1.Format("%1.0f",pDoc->m_fT[nb][0]);//iH
					if (pDoc->m_fT[nb][4]!=1e10 && OKProfilV) s4.Format("%1.0f",pDoc->m_fT[nb][4]);//jV
				}
				//luminance
				if (pDoc->m_fT[nb][1]!=1e10 && OKProfilH) s2.Format("%1.0f",pDoc->m_fT[nb][1]);//wH
				if (pDoc->m_fT[nb][2]!=1e10 && OKGaussH) s3.Format("%1.0f",pDoc->m_fT[nb][2]);//GaussH
				if (pDoc->m_fT[nb][3]!=1e10 && OKProfilV) s5.Format("%1.0f",pDoc->m_fT[nb][3]);//wV
				if (pDoc->m_fT[nb][5]!=1e10 && OKGaussV) s6.Format("%1.0f",pDoc->m_fT[nb][5]);//GaussV
				range1.SetValue(COleVariant(s1));
				range2.SetValue(COleVariant(s2));
				range3.SetValue(COleVariant(s3));
				range4.SetValue(COleVariant(s4));
				range5.SetValue(COleVariant(s5));
				range6.SetValue(COleVariant(s6));
				i++;
			}
			//Trac des graphes
			Charts charts;
			VARIANT v;
			_Chart chart1,chart2;
			charts=m_pAppli->GetCharts();
			//Units absisses
			if (pDoc->m_OKXY)
			{
				s3="iH(mm)";
				s4="0.0E+0";
			}
			else
			{
				s3="iH(pixel)";
				s4="0";
			}
			s5="0";
			//Plage de donnes profil horizontal
			if (OKProfilH || OKGaussH)
			{
				v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
				chart1=charts.Add(covOptional,covOptional,v);
				chart1.SetVisible(FALSE);
			}
			if (OKProfilH)
			{
				s1.Format("A2:A%u",pDoc->m_iNb+2);
				s2.Format("B2:B%u",pDoc->m_iNb+2);
				//											Plage de donnes
				//															Titre du graphe
				//																								Titre de la feuille
				//																															Titre axe des absisses
				GrapheExcel(sheet,chart1,s1,s2,"Profil horizontal","Trac horiz.",s3,s4,s5);
			}
			if (OKGaussH)
			{
				s1.Format("A2:A%u",pDoc->m_iNb+2);
				s2.Format("C2:C%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart1,s1,s2,"Profil horizontal","Trac horiz.",s3,s4,s5);
			}
			//Units absisses
			if (pDoc->m_OKXY)
				s3="jV(mm)";
			else
				s3="jV(pixel)";
			//Plage de donnes profil vertical
			if (OKProfilV || OKGaussV)
			{
				v=COleVariant((short)(1));//1: Nb. de sheets  ajouter
				chart2=charts.Add(covOptional,covOptional,v);
				chart2.SetVisible(FALSE);
			}	
			if (OKProfilV)
			{
				s1.Format("D2:D%u",pDoc->m_iNb+2);
				s2.Format("E2:E%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart2,s1,s2,"Profil vertical\n(A tourner dans le sens horaire)","Trac vert.",s3,s4,s5);
			}
			if (OKGaussV)
			{
				s1.Format("D2:D%u",pDoc->m_iNb+2);
				s2.Format("F2:F%u",pDoc->m_iNb+2);
				GrapheExcel(sheet,chart2,s1,s2,"Profil vertical\n(A tourner dans le sens horaire)","Trac vert.",s3,s4,s5);
			}
			//Pour ne pas avoir une demande automatique de sauvegarde...
			book.SetSaved(TRUE);
			m_pAppli->SetVisible(TRUE);
		}
	}
}
//_________________________________________________
void CExcelBk::GrapheExcel(_Worksheet sheet,_Chart chart,CString plage1,CString plage2,CString titre,CString nom,CString abs,CString FormatX,CString FormatY) 
{
	COleVariant 
		covTrue((short)TRUE),
		covFalse((short)FALSE),
		covOptional((long)DISP_E_PARAMNOTFOUND,VT_ERROR);
	LPDISPATCH pdisp;
	Axis axis;
	TickLabels tick;
	VARIANT v,v1,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11;
	Font fonte;
	PlotArea aire;
	Interior interieur;

	
	pdisp=sheet.GetRange(COleVariant(plage1),COleVariant(plage2));
	v1=COleVariant((short)(2));//Donnes en colonnes
	chart.ApplyCustomType(-4169,covOptional);
	chart.SetSourceData(pdisp,v1);
	v2=COleVariant((long)(-4169));//Nuage de points
	v3=COleVariant((short)(6));//Format: 1: points uniquement, 2:points relis, 4 & 5: chelles log, 6: courbe uniquement,7,8,9: !!
	v4=COleVariant((short)(2));//Donnes en colonnes
	v5=COleVariant((short)(1));//Donnes en colonnes
	v6=COleVariant((short)(1));//Donnes en colonnes
	v7=covTrue;//Avec noms des sries
	v8=COleVariant(titre);
	v9=COleVariant(abs);//Category axis title text.
	v10=covOptional;
	v11=covOptional;
	chart.ChartWizard(covOptional,v2,v3,v4,v5,v6,v7,v8,v9,v10,v11);
	chart.SetName(nom);
	chart.SetVisible(FALSE);
	//Absisse__________________________________________
	v=COleVariant((short)(1));
	axis=chart.Axes(v,1);//Grille absisses
	axis.SetHasMajorGridlines(TRUE);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatX);//Format division absisse
	//Ordonne_______________________________________
	v=COleVariant((short)(2));
	axis=chart.Axes(v,1);//Grille ordonne
	axis.SetHasMajorGridlines(TRUE);
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	tick=axis.GetTickLabels();
	tick.SetNumberFormat(FormatY);//Format division ordonne 
	fonte=tick.GetFont();
	v=COleVariant((short)(9));
	fonte.SetSize(v);
	aire=chart.GetPlotArea();
	interieur=aire.GetInterior();
	//v=COleVariant((long)RGB(220,220,220));//Gris
	//v=COleVariant((long)RGB(255,255,200));//Jaune clair
	v=COleVariant((long)RGB(228,230,189));//Vert clair
	//v=COleVariant((long)RGB(164,223,255));//Bleu clair
	interieur.SetColor(v);
	chart.SetVisible(TRUE);
	chart.Select(covOptional);
}
