// ExtractDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "ExtractDlg.h"
#include "BkDoc.h"
#include "BkView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CExtractDlg dialog
CExtractDlg::CExtractDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExtractDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExtractDlg)
	m_s13 = _T("");
	//}}AFX_DATA_INIT
	//A ajouter:
	Create(IDD_EXTRACT,pParent);
}
//________________________________________
void CExtractDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExtractDlg)
	DDX_Control(pDX, IDOK, m_btnOK);
	DDX_Text(pDX, IDC_STATIC13, m_s13);
	//}}AFX_DATA_MAP
}
//________________________________________
BEGIN_MESSAGE_MAP(CExtractDlg, CDialog)
	//{{AFX_MSG_MAP(CExtractDlg)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CExtractDlg message handlers
BOOL CExtractDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	SetTimer(13,100,NULL);
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CExtractDlg::OnOK() 
{
	CBkDoc *pDoc;
	short 
		i,j,
		nb,
		l,h,L,H,
		xd,yd,xa,ya;
	CMDIChildWnd * pChild;
	unsigned char 
		*wR1,*wV1,*wB1,*wR2,*wV2,*wB2;

	m_pApp->m_pExtractDlg=NULL;
	KillTimer(13);
	//1.Dimensions rectangle tracker
	xd=m_pDoc->m_tracker.m_rect.left+m_pDoc->m_iXpos;	
	xa=m_pDoc->m_tracker.m_rect.right+m_pDoc->m_iXpos;
	yd=m_pDoc->m_tracker.m_rect.top+m_pDoc->m_iYpos;
	ya=m_pDoc->m_tracker.m_rect.bottom+m_pDoc->m_iYpos;

	if (xa-xd>100 && ya-yd>100)
	{
		//2.Crer nouvelle fentre
		SendMessage(WM_COMMAND,ID_FILE_NEW,0);
		pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
		pDoc=(CBkDoc*)pChild->GetActiveDocument();
		//3.Dimensionner nouvelle fentre
		L=pDoc->m_iL=xa-xd;H=pDoc->m_iH=ya-yd;
		pDoc->DimensionnerFenetre(L,H);
		pDoc->DefinirCurseurs(L,H);
		pDoc->m_iType=m_pDoc->m_iType;
		pDoc->m_iType=pDoc->m_iType^4;
		pDoc->EcritTitre();
		/*
		//4.Rservation mmoire tableaux images
		l=m_pDoc->m_iL;
		h=m_pDoc->m_iH;

		wR1=new unsigned char[l*h];
		wV1=new unsigned char[l*h];
		wB1=new unsigned char[l*h];

		wR2=new unsigned char[L*H];
		wV2=new unsigned char[L*H];
		wB2=new unsigned char[L*H];

		//5.Extraction des luminances de l'image source
		getpixelcolor(m_pDoc->image,l,h,wR1,wV1,wB1,&nb);

		//6.Affectation luminances
		for (i=0;i<L;i++)
		{
			for (j=0;j<H;j++)
			{
				wR2[i+j*L]=wR1[(i+xd)+(j+yd)*l];
				wV2[i+j*L]=wV1[(i+xd)+(j+yd)*l];
				wB2[i+j*L]=wB1[(i+xd)+(j+yd)*l];
			}
		}
		if (nb==1)
		{
			gen_image1(&(pDoc->image),"byte",L,H,(long)wR2);
		}
		else
		{
			gen_image3(&(pDoc->image),"byte",L,H,(long)wR2,(long)wV2,(long)wB2);
		}
		set_window_extents(pDoc->m_pView->m_lWindowID,0,0,L,H);


		//7.Libration mmoire
		delete wR1;delete wV1;delete wB1;
		delete wR2;delete wV2;delete wB2;
		*/
		//Tout simplement :
		crop_part(m_pDoc->image,&(pDoc->image),yd,xd,L,H);
		set_window_extents(pDoc->m_pView->m_lWindowID,0,0,L,H);

		//8.Suppression profils, tracker, coordonnes
		m_pDoc->m_iDw=-1;
		m_pDoc->m_tracker.m_rect.SetRectEmpty();
		m_pDoc->m_iType=m_pDoc->m_iType^4;
		//m_pDoc->m_pView->Invalidate(FALSE);
		m_pDoc->m_pView->VisuHalcon();


	}
	else
		AfxMessageBox("Taille mini de la zone digitalise : 100 x 100 pixels !");	

	CDialog::OnOK();
}
//________________________________________
void CExtractDlg::OnCancel() 
{
	KillTimer(13);
	if (m_pDoc!=NULL)
	{
		m_pDoc->m_iDw=-1;
		m_pDoc->m_tracker.m_rect.SetRectEmpty();
		m_pDoc->m_iType=m_pDoc->m_iType^4;
		//m_pDoc->m_pView->Invalidate(FALSE);
		m_pDoc->m_pView->VisuHalcon();
	}
	m_pApp->m_pExtractDlg=NULL;
	CDialog::OnCancel();
}
//________________________________________
void CExtractDlg::PostNcDestroy() 
{
	delete this;
	CDialog::PostNcDestroy();
}
//________________________________________
void CExtractDlg::OnTimer(UINT nIDEvent) 
{
	short xd,yd,xa,ya;
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;

	if (m_pDoc==NULL)
	{
		m_btnOK.EnableWindow(FALSE);
		m_s13="?";
		UpdateData(FALSE);
	}
	else
	if ((m_pDoc->m_iType&8)==8)
	//FFT, ne fonctionne pas !
		m_btnOK.EnableWindow(FALSE);
	else
	{
		m_s13=m_pDoc->m_sNomFic;
		UpdateData(FALSE);

		xd=m_pDoc->m_tracker.m_rect.left;	
		xa=m_pDoc->m_tracker.m_rect.right;
		yd=m_pDoc->m_tracker.m_rect.top;
		ya=m_pDoc->m_tracker.m_rect.bottom;
		if (xa-xd<=0 || ya-yd<=0)
			m_btnOK.EnableWindow(FALSE);
		else
			m_btnOK.EnableWindow(TRUE);
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CExtractDlg::getpixelcolor(Hobject image,short l,short h,unsigned char *wR,unsigned char *wV,unsigned char *wB,short *nbchannel) 
{
	short i,j;
	long L,H,channels;
	char lpcsType[128];
	unsigned char *R,*V,*B;

	count_channels(image,&channels);
	*nbchannel=channels;
	if (channels==1) 
	{
		get_image_pointer1(image,(long*)&R,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");

		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wV[i+j*l]=*(R+i+j*l);
				wB[i+j*l]=*(R+i+j*l);
			}
		}
	}
	else
	{
		get_image_pointer3(image,(long*)&R,(long*)&V,(long*)&B,lpcsType,&L,&H);
		if (L!=l || H!=h) AfxMessageBox("Erreur sur taille image !");
		for (i=0;i<l;i++)
		{
			for (j=0;j<h;j++)
			{
				wR[i+j*l]=*(R+i+j*l);
				wV[i+j*l]=*(V+i+j*l);
				wB[i+j*l]=*(B+i+j*l);
			}
		}
	}
}
