// MainFrm.cpp : implementation of the CMainFrame class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "MainFrm.h"
#include "BkView.h"
#include "Vicdefs.h"
#include "Webcam.h"
#include "ParNumDlg.h"
#include "ParNum1Dlg.h"
#include "ParNum2Dlg.h"
#include "ExtractDlg.h"
#include "MathLogDlg.h"
#include "MultDlg.h"
#include "RedimDlg.h"
#include "FiltreDlg.h"
#include "AjustDlg.h"
#include "CalbDlg.h"
#include "CoordDlg.h"
#include "ExcelBk.h"
#include "CodeHalcon.h"
#include "GeCoDlg.h"
#include "CouCoDlg.h"
#include "SerieDlg.h"
#include "LasDlg.h"
#include "LeLeuDlg.h"
#include "MatroxOrion.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMainFrame
IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_FICHIER_OUVRIR, OnFichierOuvrir)
	ON_COMMAND(ID_FICHIER_ENREGISTRER, OnFichierEnregistrer)
	ON_COMMAND(ID_FICHIER_ENREGISTRER_SOUS, OnFichierEnregistrerSous)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_COMMAND(ID_COLLER_PRESSE_PAPIER, OnCollerPressePapier)
	ON_UPDATE_COMMAND_UI(ID_ACQPERM, OnUpdateAcqperm)
	ON_COMMAND(ID_ACQPERM, OnAcqperm)
	ON_UPDATE_COMMAND_UI(ID_ACQFIG, OnUpdateAcqfig)
	ON_COMMAND(ID_ACQFIG, OnAcqfig)
	ON_UPDATE_COMMAND_UI(ID_AUCUN, OnUpdateAucun)
	ON_COMMAND(ID_AUCUN, OnAucun)
	ON_UPDATE_COMMAND_UI(ID_WEBCAM, OnUpdateWebcam)
	ON_COMMAND(ID_WEBCAM, OnWebcam)
	ON_UPDATE_COMMAND_UI(ID_MATROXMETEORII, OnUpdateMatroxmeteorii)
	ON_COMMAND(ID_MATROXMETEORII, OnMatroxmeteorii)
	ON_UPDATE_COMMAND_UI(ID_DRIVERTWAIN, OnUpdateDrivertwain)
	ON_COMMAND(ID_DRIVERTWAIN, OnDrivertwain)
	ON_UPDATE_COMMAND_UI(ID_PARA_NUMERISEUR, OnUpdateParaNumeriseur)
	ON_COMMAND(ID_PARA_NUMERISEUR, OnParaNumeriseur)
	ON_UPDATE_COMMAND_UI(ID_IEEE1394, OnUpdateIeee1394)
	ON_COMMAND(ID_IEEE1394, OnIeee1394)
	ON_UPDATE_COMMAND_UI(ID_FICHIER_ENREGISTRER_SOUS, OnUpdateFichierEnregistrerSous)
	ON_UPDATE_COMMAND_UI(ID_FICHIER_ENREGISTRER, OnUpdateFichierEnregistrer)
	ON_UPDATE_COMMAND_UI(ID_WEBCAM1, OnUpdateWebcam1)
	ON_COMMAND(ID_WEBCAM1, OnWebcam1)
	ON_UPDATE_COMMAND_UI(ID_PARA_NUMERISEUR1, OnUpdateParaNumeriseur1)
	ON_COMMAND(ID_PARA_NUMERISEUR1, OnParaNumeriseur1)
	ON_UPDATE_COMMAND_UI(ID_MATRIXVISION_MVBLUEFOX, OnUpdateMatrixvisionMvbluefox)
	ON_COMMAND(ID_MATRIXVISION_MVBLUEFOX, OnMatrixvisionMvbluefox)
	ON_COMMAND(ID_OP_MATH_LOG, OnOpMathLog)
	ON_UPDATE_COMMAND_UI(ID_OP_MATH_LOG, OnUpdateOpMathLog)
	ON_UPDATE_COMMAND_UI(ID_CONV_NG, OnUpdateConvNg)
	ON_COMMAND(ID_CONV_NG, OnConvNg)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_COLLER_PRESSE_PAPIER, OnUpdateCollerPressePapier)
	ON_UPDATE_COMMAND_UI(ID_EXTRAIRE, OnUpdateExtraire)
	ON_COMMAND(ID_EXTRAIRE, OnExtraire)
	ON_UPDATE_COMMAND_UI(ID_CONV_COUL, OnUpdateConvCoul)
	ON_COMMAND(ID_CONV_COUL, OnConvCoul)
	ON_UPDATE_COMMAND_UI(ID_REDIMENSIONNER, OnUpdateRedimensionner)
	ON_COMMAND(ID_REDIMENSIONNER, OnRedimensionner)
	ON_UPDATE_COMMAND_UI(ID_FILTRER_IMAGE, OnUpdateFiltrerImage)
	ON_COMMAND(ID_FILTRER_IMAGE, OnFiltrerImage)
	ON_UPDATE_COMMAND_UI(ID_NEGATIF, OnUpdateNegatif)
	ON_COMMAND(ID_NEGATIF, OnNegatif)
	ON_UPDATE_COMMAND_UI(ID_GAUSS, OnUpdateGauss)
	ON_COMMAND(ID_GAUSS, OnGauss)
	ON_UPDATE_COMMAND_UI(ID_AJUSTER, OnUpdateAjuster)
	ON_COMMAND(ID_AJUSTER, OnAjuster)
	ON_UPDATE_COMMAND_UI(ID_ETALONNER, OnUpdateEtalonner)
	ON_COMMAND(ID_ETALONNER, OnEtalonner)
	ON_UPDATE_COMMAND_UI(ID_COORD_SOURIS, OnUpdateCoordSouris)
	ON_COMMAND(ID_COORD_SOURIS, OnCoordSouris)
	ON_UPDATE_COMMAND_UI(ID_EXCEL, OnUpdateExcel)
	ON_COMMAND(ID_EXCEL, OnExcel)
	ON_UPDATE_COMMAND_UI(ID_MULT_CTE, OnUpdateMultCte)
	ON_COMMAND(ID_MULT_CTE, OnMultCte)
	ON_UPDATE_COMMAND_UI(ID_MATRIXVSION_MVBLUEFOX1, OnUpdateMatrixvsionMvbluefox1)
	ON_COMMAND(ID_MATRIXVSION_MVBLUEFOX1, OnMatrixvsionMvbluefox1)
	ON_COMMAND(ID_CODE_DANS_IM, OnCodeDansIm)
	ON_UPDATE_COMMAND_UI(ID_CODE_DANS_IM, OnUpdateCodeDansIm)
	ON_COMMAND(ID_GEN_CODE, OnGenCode)
	ON_UPDATE_COMMAND_UI(ID_GEN_CODE, OnUpdateGenCode)
	ON_UPDATE_COMMAND_UI(ID_DEF_COUL, OnUpdateDefCoul)
	ON_COMMAND(ID_DEF_COUL, OnDefCoul)
	ON_COMMAND(ID_LECTEURLEUZE_CONNECTER, OnLecteurleuzeConnecter)
	ON_COMMAND(ID_GENRER_FAIS, OnGenrerFais)
	ON_COMMAND(ID_LIRECODES, OnLirecodes)
	ON_UPDATE_COMMAND_UI(ID_LIRECODES, OnUpdateLirecodes)
	ON_UPDATE_COMMAND_UI(ID_GENRER_FAIS, OnUpdateGenrerFais)
	ON_UPDATE_COMMAND_UI(ID_MATROX_ORION, OnUpdateMatroxOrion)
	ON_COMMAND(ID_MATROX_ORION, OnMatroxOrion)
	//}}AFX_MSG_MAP
	//Coordonnes dfilantes de la souris
	ON_UPDATE_COMMAND_UI(ID_BK, OnUpdateCoordonnees)
	//Units
	ON_UPDATE_COMMAND_UI(ID_BK1, OnUpdateUnites)
	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_BK,									//Coordonnes dfilantes de la souris
	ID_BK1,									//Units
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};
//________________________________________
// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	m_pApp=((CBkApp*)AfxGetApp());
}
//________________________________________
CMainFrame::~CMainFrame()
{
}
//________________________________________
int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	//Ouverture plein cran
	ShowWindow(SW_SHOWMAXIMIZED);
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}
//________________________________________
BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	return CMDIFrameWnd::PreCreateWindow(cs);
}
//________________________________________
// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}
void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG
//________________________________________
// CMainFrame message handlers
void CMainFrame::OnUpdateUnites(CCmdUI *pCmdUI)
{
	short i,j,NbB;
	CString 
		r,l,
		s1="",s="";
	long channels;
	class CBkDoc* pDoc=NULL;
	m_wndStatusBar.SetPaneInfo(2,ID_BK1,SBPS_NORMAL,250);		
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}

	if (m_pApp->pDocGrab!=NULL)
	{
		s1="";
	}
	else
	if (pDoc!=NULL)
	{
		//Nb. de bits par pixel de l'image
		count_channels(pDoc->image,&channels);NbB=channels*8;
		
		if (pDoc->m_OKXY)
			s.Format("X,Y(mm)*%1.0e",1/pDoc->m_fFactXY);
		else
			s.Format("X,Y(pixel)");
		
		//Suppression des 0 de X,Y(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s.GetLength()-2;
			if (s.GetAt(i)=='0')
			{
				r=s.Right(1);
				l=s.Left(i-1);
				s=l+r;
			}
		}
		if (NbB==8)
		{
			s1.Format("%s, W(luminance)",s);
		}
		else
		{
			s1.Format("%s, RVB(luminance)",s);
		}
		//Suppression des 0 de Z(mm)*1E+002
		for (j=0;j<2;j++)
		{
			i=s1.GetLength()-2;
			if (s1.GetAt(i)=='0')
			{
				r=s1.Right(1);
				l=s1.Left(i-1);
				s1=l+r;
			}
		}
		
	}
	if (m_pApp->m_pCoordDlg!=NULL) m_pApp->m_pCoordDlg->Affecte1(s1);
	pCmdUI->SetText(s1); 
}
//________________________________________
void CMainFrame::OnUpdateCoordonnees(CCmdUI *pCmdUI)
{
	CString 
		str="",s,s1,s2,s3,s4;
	short x,y,NbB;
	float xmm,ymm,zmm;
	long w,channels;
	unsigned char r,g,b,r1,g1,b1;
	class CBkDoc* pDoc=NULL;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument();
	}
	m_wndStatusBar.SetPaneInfo(1,ID_BK,SBPS_NORMAL,300);		
	if (pDoc!=NULL)
	{
		//Nb. de bits par pixel de l'image
		count_channels(pDoc->image,&channels);NbB=channels*8;
		if (m_pApp->pDocGrab!=NULL)
		{
			str.Format("Acq. permanente: %s",m_pApp->pDocGrab->m_sNomFic);
		}
		else
		{
			x=pDoc->m_iX-pDoc->m_iDx;
			y=pDoc->m_iY-pDoc->m_iDy;
			if (NbB==8)
			{
				//Image en 8 bits
				w=pDoc->m_iW-pDoc->m_iDw;
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0f*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0f*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("X:%1.3f",xmm);
						s1.Format("Y:%1.3f",ymm);
					}
					else
					{
						//Pixel
						s.Format("X:%d",x);
						s1.Format("Y:%d",y);
					}
					//Luminance
					s2.Format("W:%d",pDoc->m_iW);
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0f*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0f*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f",xmm);
						s1.Format("dY:%1.3f",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d",x);
						s1.Format("dY:%d",y);
					}
					//Luminance
					s2.Format("dW:%d",w);
				}
				str.Format("%s, %s, %s",s,s1,s2);
				if (m_pApp->m_pCoordDlg!=NULL) m_pApp->m_pCoordDlg->Affecte(s,s1,s2,"","");
			}
			else
			if (NbB==24)
			{
				//Image en 24 bits
				if (pDoc->m_iDx==0 && pDoc->m_iDy==0)
				{
					w=pDoc->m_iW-pDoc->m_iDw;
					//Coordonnes absolues
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0f*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0f*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("X:%d,",x);
						s1.Format("Y:%d,",y);
					}
					//luminance
					if (w==16777216)
					{
						//Erreur d'affichage sur image "blanche"
						s2.Format("R:%d,",255); 
						s3.Format("V:%d,",255); 
						s4.Format("B:%d",255);
					}
					else
					{
						s2.Format("R:%d,",w&255); 
						s3.Format("V:%d,",(w/256)&255); 
						s4.Format("B:%d",(w/65536)&255);
					}
				}
				else
				{
					//Coordonnes relatives
					if (pDoc->m_OKXY)
					{
						//mm
						xmm=1.0f*x*pDoc->m_fFactXY/pDoc->m_fEchXY;
						ymm=1.0f*y*pDoc->m_fFactXY/pDoc->m_fEchXY;
						s.Format("dX:%1.3f,",xmm);
						s1.Format("dY:%1.3f,",ymm);
					}
					else
					{
						//pixel
						s.Format("dX:%d,",x);
						s1.Format("dY:%d,",y);
					}
					//luminance
					w=(pDoc->m_iW&255)-(pDoc->m_iDw&255);
					s2.Format("dR:%d,",w);
					w=((pDoc->m_iW/256)&255)-((pDoc->m_iDw/256)&255);
					s3.Format("dV:%d,",w); 
					w=((pDoc->m_iW/65536)&255)-((pDoc->m_iDw/65536)&255);
					s4.Format("dB:%d",w);
				}
				str.Format("%s %s %s %s %s",s,s1,s2,s3,s4);
				if (m_pApp->m_pCoordDlg!=NULL) m_pApp->m_pCoordDlg->Affecte(s,s1,s2,s3,s4);
			}		 
		}
	}
	else
	{
		str="";
	}
	pCmdUI->SetText(str);
}
//________________________________________
void CMainFrame::FigerAcq() 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (m_pApp->pDocGrab!=NULL)
			{
				pDoc->FigerAcq();
			}
		}
	}
}
//________________________________________
void CMainFrame::AcqPerm() 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (m_pApp->pDocGrab==NULL)
			{
				pDoc->AcqPerm();
			}
		}
	}
}
//________________________________________
void CMainFrame::OnFichierOuvrir() 
{
	CString s;
	static char BASED_CODE szFilter[]="Fichiers images (*tif;*.jpg)|*.tif;*.jpg|Fichiers images (*.tif)|*.tif|Fichiers images (*.jpg)|*.jpg|Tous les fichiers (*.*)|*.*||";
	CFileDialog dlg(TRUE,"","",0,szFilter,NULL) ;
	if (dlg.DoModal()==IDOK)
	{
		s=dlg.GetPathName();
		CFile f;
		char buf[512];
		if(!f.Open(s,CFile::modeRead) )
		{
			AfxMessageBox("Erreur d'ouverture fichier:"+s);
		}
		else
		{
			SendMessage(WM_COMMAND,ID_FILE_NEW,0);
			CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
			CBkDoc *pDoc;
			if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
			if (pDoc)
			{
				CArchive ar(&f,CArchive::load,512,buf);
				pDoc->LitImage(ar);
			}
		}
	}	
}
//________________________________________
void CMainFrame::OnUpdateFichierEnregistrer(CCmdUI* pCmdUI) 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
		else
			pDoc=NULL;
	}
	else
		pDoc=NULL;
	if (pDoc==NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFichierEnregistrer() 
{
	CFile f;
	char buf[512];
	CFileException p_Error;
	BOOL ok;
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	CBkDoc *pDoc;
	if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
	CArchive ar(&f,CArchive::store,512,buf);
	if (pDoc)
	{
		ok=f.Open(pDoc->m_sNomFic,CFile::modeWrite|CFile::modeCreate,&p_Error);
		if (!ok)
		{
			AfxMessageBox("Erreur d'criture fichier:"+pDoc->m_sNomFic);
		}
		else
		{
			CArchive ar(&f,CArchive::store,512,buf);
			pDoc->Serialize(ar);
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateFichierEnregistrerSous(CCmdUI* pCmdUI) 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
		else
			pDoc=NULL;
	}
	else
		pDoc=NULL;
	if (pDoc==NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnFichierEnregistrerSous() 
{
	CString s;
	CFile f;
	char buf[512];
	static char BASED_CODE szFilter[]="Fichier image (*.tif)|*.tif|Fichier image (*.jpg)|*.jpg||";
	CFileException p_Error;
	BOOL ok;
	short j=IDYES;
	CFileDialog dlg(FALSE,"","",0,szFilter,NULL) ;
	if (dlg.DoModal()==IDOK)
	{
		s=dlg.GetPathName();
		//Ouverture du fichier en mode READ			
		ok=f.Open(dlg.GetPathName(),CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) f.Close();
			//Ouverture du fichier en mode CREATE			
			ok=f.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate,&p_Error);
			if (!ok)
			{
				AfxMessageBox("Erreur d'criture fichier:"+s);
			}
			else
			{
				CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
				CBkDoc *pDoc;
				if (pChild) pDoc=(CBkDoc*)pChild->GetActiveDocument(); else pDoc=NULL;
				CArchive ar(&f,CArchive::store,512,buf);
				if (pDoc)
				{
					pDoc->m_sNomFic=dlg.GetPathName();
					CArchive ar(&f,CArchive::store,512,buf);
					pDoc->Serialize(ar);
				}
			}
		}	
	}
}
//________________________________________
void CMainFrame::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	long nb;
	CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if ((pDoc->m_iType&8)!=0 || (pDoc->m_iType&16)!=0) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnEditCopy() 
{
	//Copier
	unsigned char *dib;
	short 
		i,j,
		rcode;
	HGLOBAL hMem;
	class CBkDoc* pDoc;
	class CBkView* pView;
	long
		p,L,H,
		w,w1,w2,w3,channels;
	unsigned char 
		*m_R,*m_G,*m_B,
		*wR,*wG,*wB;
	char lpcsType[128];
	imgdes im;

	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			pView=(CBkView*)pChild->GetActiveView();
			FigerAcq();
			//N image  copier
			m_pApp->m_pDocACopier=pDoc;
			L=pDoc->m_iL;
			H=pDoc->m_iH;
			m_R=new unsigned char[L*H];
			m_G=new unsigned char[L*H];
			m_B=new unsigned char[L*H];
			count_channels(pDoc->image,&channels);
			allocimage(&im,pDoc->m_iL,pDoc->m_iH,channels*8);
			if (channels==3)
			{
				get_image_pointer3(pDoc->image,(long*)&wR,(long*)&wG,(long*)&wB,lpcsType,&L,&H);
				for (p=0;p<L*H;p++)
				{
					m_R[p]=*(wR+p);
					m_G[p]=*(wG+p);
					m_B[p]=*(wB+p);
				}
			}
			else
			{
				get_image_pointer1(pDoc->image,(long*)&wR,lpcsType,&L,&H);
				for (p=0;p<L*H;p++)	m_R[p]=*(wR+p);
			}
			for (i=0;i<pDoc->m_iL;i++)
			{
				for (j=0;j<pDoc->m_iH;j++)
				{
					if (channels==1)
					{
						w=m_R[i+j*L]&255;
					}
					else
					{
						w1=m_R[i+j*L];
						w1=w1&255;
						w2=m_G[i+j*L];
						w2=w2&255;
						w3=m_B[i+j*L];
						w3=w3&255;
						w=w1+256*w2+256*256*w3;
					}
					setpixelcolor(&im,i,j,w);
				}
			}
			//Copier aussi dans le presse-papier Windows
			if (OpenClipboard())
			{
				EmptyClipboard();
				rcode=imagetodib(&im,&dib);
				if (rcode==0)
				{
					hMem=(HGLOBAL)GlobalHandle(dib);
					GlobalUnlock(hMem);
					SetClipboardData(CF_DIB,hMem);
					CloseClipboard();	
				}		
			}
			freeimage(&im);
			delete m_R;delete m_G;delete m_B;
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pDocACopier==NULL || m_pApp->pDocGrab!=NULL) 	pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnEditPaste() 
{
	long l,h,nb;
	char lpcsType[128];
	unsigned char *R,*G,*B;
	CBkDoc *pDoc;
	CBkView *pView;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			count_channels(m_pApp->m_pDocACopier->image,&nb);
			if (nb==1) 
				get_image_pointer1(m_pApp->m_pDocACopier->image,(long*)&R,lpcsType,&l,&h);
			else
				get_image_pointer3(m_pApp->m_pDocACopier->image,(long*)&R,(long*)&G,(long*)&B,lpcsType,&l,&h);

			pView=(CBkView*)pChild->GetActiveView();
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			FigerAcq();
			pDoc->m_iL=l;
			pDoc->m_iH=h;

			if (pDoc->m_iL<m_pApp->m_iLmax)
				l=pDoc->m_iL;
			else
				l=m_pApp->m_iLmax;
			if (pDoc->m_iH<m_pApp->m_iHmax)
				h=pDoc->m_iH;
			else
				h=m_pApp->m_iHmax;
			pDoc->m_sNomFic.Format("Im_Copie%d",pDoc->m_iNo);//m_pApp->m_pDocACopier->m_sNomFic;
			pDoc->EcritTitre();
			pView->SetScrollSizes(MM_TEXT,CSize(pDoc->m_iL,pDoc->m_iH));
			pDoc->DimensionnerFenetre(l,h);
			set_window_extents(pView->m_lWindowID,0,0,pDoc->m_iL,pDoc->m_iH);
			copy_image(m_pApp->m_pDocACopier->image,&(pDoc->image));
			//Image seule
			pDoc->m_iType=0;
			//Coordonnes absolues
			pDoc->m_iDx=0;pDoc->m_iDy=0;pDoc->m_iDw=-1;
			//Suppression rectangle tracker
			pDoc->InitTracker();
		}
	}		
}
//________________________________________
void CMainFrame::OnUpdateCollerPressePapier(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCollerPressePapier() 
{
	//Coller en provenance du presse-papier Windows
	unsigned char huge *dib;
	short 
		rcode;
	short i,j,l,h,n;
	long w;
	HGLOBAL hMem;
	CBkDoc *pDoc;
	CBkView *pView;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			pView=(CBkView*)pChild->GetActiveView();
			if (OpenClipboard())
			{
				if ((hMem=GetClipboardData(CF_DIB))!=0)
				{
					dib=(unsigned char huge *)GlobalLock(hMem);
					//On passe par Victor
					imgdes im;
					//La fonction suivante alloue aussi la mmoire...
					rcode=dibtoimage(dib,&im);
					if (rcode!=0) AfxMessageBox("Erreur sur fonction dibtoimage !");
					GlobalUnlock(hMem);
					CloseClipboard();	
	
					l=im.endx-im.stx+1;
					h=im.endy-im.sty+1;

					//Paramtrer la fentre destination
					pDoc->DimensionnerFenetre(l,h);
					pDoc->DefinirCurseurs(l,h);
					pDoc->m_iType=0;
					//Copier l'image Victor dans Halcon
					set_window_extents(pView->m_lWindowID,0,0,l,h);
					unsigned char *R,*G,*B;
					R=new unsigned char[l*h];
					G=new unsigned char[l*h];
					B=new unsigned char[l*h];
					for (i=0;i<l;i++)
					{
						for (j=0;j<h;j++)
						{
							w=getpixelcolor(&im,i,j);
							R[i+j*l]=w&255; 
							G[i+j*l]=(w/256)&255; 
							B[i+j*l]=(w/65536)&255; 
						}
					}
					freeimage(&im);

					gen_image3(&(pDoc->image),"byte",(long)l,(long)h,(long)R,(long)G,(long)B);
					delete R;delete G;delete B;
					pDoc->m_iL=l;
					pDoc->m_iH=h;
					pDoc->UpdateAllViews(NULL);
				}
				else
				{
					AfxMessageBox("Erreur sur fonction GetClipboardData(CF_DIB) !");
				}
			}
			else
			{
				AfxMessageBox("Erreur sur fonction OpenClipboard !");
			}
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateAcqperm(CCmdUI* pCmdUI) 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (m_pApp->m_iCarte==0 || m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
		}
		else
			pCmdUI->Enable(FALSE);
	}
}
//________________________________________
void CMainFrame::OnAcqperm() 
{
	AcqPerm();
}
//________________________________________
void CMainFrame::OnUpdateAcqfig(CCmdUI* pCmdUI) 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (m_pApp->m_iCarte==0 || m_pApp->pDocGrab==NULL) pCmdUI->Enable(FALSE);
		}
		else
			pCmdUI->Enable(FALSE);
	}
}
//________________________________________
void CMainFrame::OnAcqfig() 
{
	CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			FigerAcq();
		}
	}
}
//Gestion des numriseurs_________________
void CMainFrame::OnUpdateAucun(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==0) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
void CMainFrame::OnAucun() 
{
	m_pApp->m_iCarte=0;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
	/*
	m_pApp->m_iL=m_pApp->m_sizeFen.cx/2-20;
	m_pApp->m_iH=480*m_pApp->m_iL/640;
	*/
}
void CMainFrame::OnUpdateDrivertwain(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==1) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
void CMainFrame::OnDrivertwain() 
{
	//Test Twain
	Herror err;
	char message[MAX_STRING],information[MAX_STRING],val[MAX_STRING];
	close_all_framegrabbers();
	set_check("~give_error");
	err=info_framegrabber("TWAIN","parameters",information,val);
	if (err!=2)
	{
		//CString z;z.Format("%s : %s",information[0],val[1]);
		AfxMessageBox("Pilote twain non trouv !");
		m_pApp->m_iCarte=0;
	}
	else
	{
		m_pApp->m_iCarte=1;
	}
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
	set_check("give_error");
}
void CMainFrame::OnUpdateWebcam(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==2) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
void CMainFrame::OnWebcam() 
{
	//Video for Windows
	m_pApp->m_iCarte=2;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
	close_all_framegrabbers();
}
//________________________________________
void CMainFrame::OnUpdateWebcam1(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==3) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnWebcam1() 
{
	//Direct Show
	m_pApp->m_iCarte=3;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
	/*
	BOOL ok=FALSE;
	if (m_pApp->m_iL==640) ok=TRUE;
	if (m_pApp->m_iL==320) ok=TRUE;
	if (!ok)
	{
		m_pApp->m_iL=640;m_pApp->m_iH=480;
	}
	*/
	close_all_framegrabbers();
}
//________________________________________
void CMainFrame::OnUpdateMatroxOrion(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==8) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnMatroxOrion() 
{
	//Test Orion
	CString z;
	close_all_framegrabbers();
	/*
	short err=m_pApp->m_pOrion->TestOrion();
	if (err!=0)
	{
		CString z;z.Format("Carte Matrox Orion non trouve ou dj adresse !\nErreur TestOrion() n%d.",err);
		AfxMessageBox(z);
		m_pApp->m_iCarte=0;
	}
	else
	{
		m_pApp->m_iCarte=8;
	}
	*/
	m_pApp->m_iCarte=8;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
}
//________________________________________
void CMainFrame::OnUpdateMatroxmeteorii(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==4) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnMatroxmeteorii() 
{
	//Test Meteor
	CString z;
	close_all_framegrabbers();

	m_pApp->m_iCarte=4;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);

	/*
	HINSTANCE hDLL;
	BOOL ok;
	typedef short (*INITMETEOR)(short *L,short *H);
	typedef void (*LIBEREMETEOR)(void);
	typedef short (*TESTMETEOR)(void);
	INITMETEOR InitMeteor;
	LIBEREMETEOR LibereMeteor;
	TESTMETEOR TestMeteor;
	hDLL=LoadLibrary("MeteorBk.dll");
	if (hDLL!=NULL)
	{
		ok=TRUE;
		InitMeteor=(short (*)(short*,short*))GetProcAddress(hDLL,"InitMeteor");
		if (InitMeteor==NULL)
		{ 
			AfxMessageBox("Fonction InitMeteor non trouve dans MeteorBk.dll !");
			ok=FALSE;
		}
		LibereMeteor=(void (*)(void))GetProcAddress(hDLL,"LibereMeteor");
		if (InitMeteor==NULL)
		{ 
			AfxMessageBox("Fonction LibereMeteor non trouve dans MeteorBk.dll !");
			ok=FALSE;
		}
		TestMeteor=(short (*)(void))GetProcAddress(hDLL,"TestMeteor");
		if (TestMeteor==NULL)
		{ 
			AfxMessageBox("Fonction TestMeteor non trouve dans MeteorBk.dll !");
			ok=FALSE;
		}
	}
	else
	{
		AfxMessageBox("Librairie MeteorBk.dll non trouve !");
		ok=FALSE;
	}
	if (ok)
	{
		//On cherche la carte Meteor via MeteorBk.dll 
		if (TestMeteor()==0)
		//short L,H;
		//if (InitMeteor(&L,&H)==0)
		{
			AfxMessageBox("Carte Meteor II non trouve ou dj adresse !");
			m_pApp->m_iCarte=0;
		}
		else
		{
			m_pApp->m_iCarte=4;
			//z.Format("L:%d\nH:%d",L,H);AfxMessageBox(z);
			//On libre les ressources Meteor pour pouvoir utiliser le driver Halcon
			//LibereMeteor();
		}
	}
	*/
	/*
	//Ne fonctionne pas !
	set_check("~give_error");
	long l;
	HTuple InfoVal,Info;
	info_framegrabber(HTuple("MeteorII"),HTuple("ports"),&Info,&InfoVal);
	tuple_sort(InfoVal,&InfoVal);
	l=InfoVal[0];
	z.Format("%ld",l);AfxMessageBox(z);
	if (l==0)
	{
		AfxMessageBox("Carte Meteor II non trouve !");
		m_pApp->m_iCarte=0;
	}
	else
		m_pApp->m_iCarte=4;
	set_check("give_error");
	*/
}
//________________________________________
void CMainFrame::OnUpdateIeee1394(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==5) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnIeee1394() 
{
	//Test IEEE 1394
	char information[MAX_STRING],val[MAX_STRING]="";
	set_check("~give_error");
	close_all_framegrabbers();
	info_framegrabber(HTuple("1394IIDC"),HTuple("info_boards"),information,val);
	CString z;z.Format("%s",val);
	if (z.GetLength()==0)
	{
		//AfxMessageBox(z);
		AfxMessageBox("Camra firewire sur port IEEE non trouve !");
		m_pApp->m_iCarte=0;
	}
	else
	{
		m_pApp->m_iCarte=5;
	}
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
	set_check("give_error");
}
//________________________________________
void CMainFrame::OnUpdateMatrixvisionMvbluefox(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==6) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnMatrixvisionMvbluefox() 
{
	//102C ou 102G (1280 x 1024)
	close_all_framegrabbers();
	m_pApp->m_iCarte=6;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
}
//________________________________________
void CMainFrame::OnUpdateMatrixvsionMvbluefox1(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iCarte==7) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnMatrixvsionMvbluefox1() 
{
	//120C ou 120G (640 x 480)
	close_all_framegrabbers();
	m_pApp->m_iCarte=7;
	m_pApp->AffecteResolutions(m_pApp->m_iCarte);
}
//________________________________________
void CMainFrame::OnUpdateParaNumeriseur(CCmdUI* pCmdUI) 
{
	//Invalide en acquisition permanente
	if (m_pApp->pDocGrab!=NULL || m_pApp->m_iCarte==1) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnParaNumeriseur() 
{
	//Taille des fentres par dfaut
	CParNumDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateParaNumeriseur1(CCmdUI* pCmdUI) 
{
	//Pour carte IEEE et mvBlueFOX
	if (m_pApp->pDocGrab!=NULL || m_pApp->m_iCarte<5) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnParaNumeriseur1() 
{
	//Gain et temps d'intgration
	if (m_pApp->m_iCarte==5)
	{
		//IEEE 1394
		CParNum1Dlg d;
		d.DoModal();
		//On se remet en acquisition permanente
		//AcqPerm();
	}
	else
	if (m_pApp->m_iCarte==6)
	{
		//mvBlueFOX
		CParNum2Dlg d;
		d.DoModal();
		//On se remet en acquisition permanente
		//AcqPerm();
	}
}
//________________________________________
//________________________________________
//________________________________________
void CMainFrame::OnUpdateOpMathLog(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnOpMathLog() 
{
	CMathLogDlg d;
	d.DoModal();	
}
//________________________________________
//________________________________________
//________________________________________
void CMainFrame::OnUpdateConvNg(CCmdUI* pCmdUI) 
{
	long nb;
	CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			count_channels(pDoc->image,&nb);
			if (nb==1) pCmdUI->Enable(FALSE);
			if ((pDoc->m_iType&8)!=0 || (pDoc->m_iType&16)!=0) pCmdUI->Enable(TRUE);
		}
	}
}
//________________________________________
void CMainFrame::OnConvNg() 
{
	CBkDoc *pDoc,*pd1;
	short l,h;
	Herror err;
	set_check("~give_error");
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();

			l=pDoc->m_iL;h=pDoc->m_iH;
			SendMessage(WM_COMMAND,ID_FILE_NEW,0);
			pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
			pd1=(CBkDoc*)pChild->GetActiveDocument();
			pd1->m_iL=l;pd1->m_iH=h;;
			pd1->DimensionnerFenetre(l,h);
			pd1->DefinirCurseurs(l,h);
			set_window_extents(pd1->m_pView->m_lWindowID,0,0,l,h);
			if ((pDoc->m_iType&8)!=0)
			{
				//Image FFT complexe
				err=power_byte(pDoc->image,&(pd1->image));	
				if (err!=2) AfxMessageBox("Image NG non calculable !");
			}
			else
			if ((pDoc->m_iType&16)!=0)
			{
				//Image FFT phase ou module
				err=convert_image_type(pDoc->image,&(pd1->image),"byte");	
				if (err!=2) AfxMessageBox("Image NG non calculable !");
			}
			else
			{
				//Image couleur  convertir...
				err=access_channel((pDoc->image),&(pd1->image),1);
				if (err!=2) AfxMessageBox("Image NG non calculable !");
				/*
				unsigned char 
					*R,*G,*B,*wR,*wG,*wB,*w;
				R=new unsigned char[l*h];
				G=new unsigned char[l*h];
				B=new unsigned char[l*h];
				w=new unsigned char[l*h];
				long p,L,H,nb;
				short i,j;
				char lpcsType[128];
				unsigned char r,g,b;
				count_channels(pDoc->image,&nb);
				if (nb==3)
				{
					get_image_pointer3(pDoc->image,(long*)&wR,(long*)&wG,(long*)&wB,lpcsType,&L,&H);
					for (p=0;p<L*H;p++)
					{
						R[p]=*(wR+p);
						G[p]=*(wG+p);
						B[p]=*(wB+p);
						r=R[p];
						g=G[p];//if (g!=0) AfxMessageBox("ici");
						b=B[p];
						long r=(30*r+59*g+11*b)/100;
						w[p]=(unsigned char)(r);
					}
					gen_image1(&(pd1->image),"byte",L,H,(long)w);
				}
				delete R;delete G;delete B;delete w;
				*/
			}
		}	
	}
	set_check("give_error");
}
//________________________________________
void CMainFrame::OnUpdateConvCoul(CCmdUI* pCmdUI) 
{
	long nb;
	CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			count_channels(pDoc->image,&nb);
			if (nb!=1) pCmdUI->Enable(FALSE);
			if ((pDoc->m_iType&8)!=0 || (pDoc->m_iType&16)!=0) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnConvCoul() 
{
	CBkDoc *pDoc,*pd1;
	short 
		i,j,l,h;
	long 
		L,H;
	unsigned char *w,*W;
	char lpcsType[128];
	Herror err;
	set_check("~give_error");
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();

			l=pDoc->m_iL;h=pDoc->m_iH;
			SendMessage(WM_COMMAND,ID_FILE_NEW,0);
			pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
			pd1=(CBkDoc*)pChild->GetActiveDocument();
			pd1->m_iL=l;pd1->m_iH=h;;
			pd1->DimensionnerFenetre(l,h);
			pd1->DefinirCurseurs(l,h);

			get_image_pointer1(pDoc->image,(long*)&w,lpcsType,&L,&H);
			W=new unsigned char[L*H];
			for (i=0;i<L;i++)
			{
				for (j=0;j<H;j++)
				{
					W[i+j*l]=w[i+j*L];
				}
			}
			gen_image3(&(pd1->image),"byte",L,H,(long)W,(long)W,(long)W);
			set_window_extents(pd1->m_pView->m_lWindowID,0,0,l,h);

			delete W;
			//Image   convertir...
			//err=access_channel((pDoc->image),&(pd1->image),1);

		}	
	}
	set_check("give_error");
}
//________________________________________
void CMainFrame::OnUpdateExtraire(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL || m_pApp->m_pExtractDlg!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnExtraire() 
{
	//Ouverture bote de dialogue non modale si elle n'est pas dj ouverte
	if (m_pApp->m_pExtractDlg==NULL) m_pApp->m_pExtractDlg=new CExtractDlg(this);
}
//________________________________________
void CMainFrame::OnUpdateRedimensionner(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			//FFT
			if ((pDoc->m_iType&8)==8 || (pDoc->m_iType&16)==16) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnRedimensionner() 
{
	CRedimDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateFiltrerImage(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			//FFT
			if ((pDoc->m_iType&8)==8 || (pDoc->m_iType&16)==16) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnFiltrerImage() 
{
	CFiltreDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateNegatif(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			//FFT
			if ((pDoc->m_iType&8)==8 || (pDoc->m_iType&16)==16) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnNegatif() 
{
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			invert_image((pDoc->image),&(pDoc->image));	
			pDoc->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateGauss(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (pDoc->m_OKGauss) pCmdUI->SetCheck(TRUE); else pCmdUI->SetCheck(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnGauss() 
{
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			pDoc->m_OKGauss=!pDoc->m_OKGauss;	
			pDoc->UpdateAllViews(NULL);
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateAjuster(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			//FFT
			if ((pDoc->m_iType&8)==8 || (pDoc->m_iType&16)==16) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnAjuster() 
{
	CAjustDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateMultCte(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (m_pApp->pDocGrab!=NULL) 
		pCmdUI->Enable(FALSE);
	else
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			//FFT
			if ((pDoc->m_iType&8)==8 || (pDoc->m_iType&16)==16) pCmdUI->Enable(FALSE);
		}
	}
}
//________________________________________
void CMainFrame::OnMultCte() 
{
	CMultDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateEtalonner(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnEtalonner() 
{
	CCalbDlg d;
	d.DoModal();
	//Ouverture bote de dialogue des coordonnes de la souris
	if(m_pApp->m_pCoordDlg==NULL)	m_pApp->m_pCoordDlg=new CCoordDlg(this);
}
//________________________________________
void CMainFrame::OnUpdateCoordSouris(CCmdUI* pCmdUI) 
{
	if(m_pApp->m_pCoordDlg!=NULL)
		pCmdUI->SetCheck(TRUE); 
	else
		pCmdUI->SetCheck(FALSE);
}
//________________________________________
void CMainFrame::OnCoordSouris() 
{
	if(m_pApp->m_pCoordDlg==NULL)	
		m_pApp->m_pCoordDlg=new CCoordDlg(this);
	else
		m_pApp->m_pCoordDlg->Supprime();
}
//________________________________________
void CMainFrame::OnUpdateExcel(CCmdUI* pCmdUI) 
{
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			if (m_pApp->pDocGrab!=NULL || (pDoc->m_iType&4)!=4) pCmdUI->Enable(FALSE);
		}
		else
			pCmdUI->Enable(FALSE);
	}
	else
		pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnExcel() 
{
	class CBkDoc *pDoc;
	if (AfxGetApp()->m_pMainWnd)
	{
		CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
		if (pChild) 
		{
			pDoc=(CBkDoc*)pChild->GetActiveDocument();
			CExcelBk c;
			c.EcritureExcel(pDoc);
			AfxMessageBox("Exportation vers Excel demande...");
		}
	}
}
//________________________________________
void CMainFrame::OnUpdateCodeDansIm(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_pCodeDlg!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnCodeDansIm() 
{
	if(m_pApp->m_pCodeDlg==NULL)	m_pApp->m_pCodeDlg=new CCodeHalcon(this);
}
//________________________________________
void CMainFrame::OnUpdateGenCode(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnGenCode() 
{
	CGeCoDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateDefCoul(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL) pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnDefCoul() 
{
	CCouCoDlg d;	
	d.DoModal();
}
//________________________________________
void CMainFrame::OnLecteurleuzeConnecter() 
{
	CSerieDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateGenrerFais(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CMainFrame::OnGenrerFais() 
{
	CLasDlg d;
	d.DoModal();
}
//________________________________________
void CMainFrame::OnUpdateLirecodes(CCmdUI* pCmdUI) 
{
	if (m_pApp->pDocGrab!=NULL)  pCmdUI->Enable(FALSE);
	
}
//________________________________________
void CMainFrame::OnLirecodes() 
{
	CLeLeuDlg d;
	d.DoModal();
}
