// MainFrm.h : interface of the CMainFrame class
class CMainFrame : public CMDIFrameWnd
{
	DECLARE_DYNAMIC(CMainFrame)
public:
	CMainFrame();

// Attributes
public:
protected:
	class CBkApp* m_pApp;

// Operations
public:

protected:
	void FigerAcq();
	void AcqPerm();
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMainFrame)
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CStatusBar  m_wndStatusBar;
	CToolBar    m_wndToolBar;

// Generated message map functions
protected:
	//{{AFX_MSG(CMainFrame)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnUpdateCoordonnees(CCmdUI *pCmdUI);
	afx_msg void OnUpdateUnites(CCmdUI *pCmdUI);
	afx_msg void OnFichierOuvrir();
	afx_msg void OnFichierEnregistrer();
	afx_msg void OnFichierEnregistrerSous();
	afx_msg void OnEditCopy();
	afx_msg void OnEditPaste();
	afx_msg void OnUpdateEditPaste(CCmdUI* pCmdUI);
	afx_msg void OnCollerPressePapier();
	afx_msg void OnUpdateAcqperm(CCmdUI* pCmdUI);
	afx_msg void OnAcqperm();
	afx_msg void OnUpdateAcqfig(CCmdUI* pCmdUI);
	afx_msg void OnAcqfig();
	afx_msg void OnUpdateAucun(CCmdUI* pCmdUI);
	afx_msg void OnAucun();
	afx_msg void OnUpdateWebcam(CCmdUI* pCmdUI);
	afx_msg void OnWebcam();
	afx_msg void OnUpdateMatroxmeteorii(CCmdUI* pCmdUI);
	afx_msg void OnMatroxmeteorii();
	afx_msg void OnUpdateDrivertwain(CCmdUI* pCmdUI);
	afx_msg void OnDrivertwain();
	afx_msg void OnUpdateParaNumeriseur(CCmdUI* pCmdUI);
	afx_msg void OnParaNumeriseur();
	afx_msg void OnUpdateIeee1394(CCmdUI* pCmdUI);
	afx_msg void OnIeee1394();
	afx_msg void OnUpdateFichierEnregistrerSous(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFichierEnregistrer(CCmdUI* pCmdUI);
	afx_msg void OnUpdateWebcam1(CCmdUI* pCmdUI);
	afx_msg void OnWebcam1();
	afx_msg void OnUpdateParaNumeriseur1(CCmdUI* pCmdUI);
	afx_msg void OnParaNumeriseur1();
	afx_msg void OnUpdateMatrixvisionMvbluefox(CCmdUI* pCmdUI);
	afx_msg void OnMatrixvisionMvbluefox();
	afx_msg void OnOpMathLog();
	afx_msg void OnUpdateOpMathLog(CCmdUI* pCmdUI);
	afx_msg void OnUpdateConvNg(CCmdUI* pCmdUI);
	afx_msg void OnConvNg();
	afx_msg void OnUpdateEditCopy(CCmdUI* pCmdUI);
	afx_msg void OnUpdateCollerPressePapier(CCmdUI* pCmdUI);
	afx_msg void OnUpdateExtraire(CCmdUI* pCmdUI);
	afx_msg void OnExtraire();
	afx_msg void OnUpdateConvCoul(CCmdUI* pCmdUI);
	afx_msg void OnConvCoul();
	afx_msg void OnUpdateRedimensionner(CCmdUI* pCmdUI);
	afx_msg void OnRedimensionner();
	afx_msg void OnUpdateFiltrerImage(CCmdUI* pCmdUI);
	afx_msg void OnFiltrerImage();
	afx_msg void OnUpdateNegatif(CCmdUI* pCmdUI);
	afx_msg void OnNegatif();
	afx_msg void OnUpdateGauss(CCmdUI* pCmdUI);
	afx_msg void OnGauss();
	afx_msg void OnUpdateAjuster(CCmdUI* pCmdUI);
	afx_msg void OnAjuster();
	afx_msg void OnUpdateEtalonner(CCmdUI* pCmdUI);
	afx_msg void OnEtalonner();
	afx_msg void OnUpdateCoordSouris(CCmdUI* pCmdUI);
	afx_msg void OnCoordSouris();
	afx_msg void OnUpdateExcel(CCmdUI* pCmdUI);
	afx_msg void OnExcel();
	afx_msg void OnUpdateMultCte(CCmdUI* pCmdUI);
	afx_msg void OnMultCte();
	afx_msg void OnUpdateMatrixvsionMvbluefox1(CCmdUI* pCmdUI);
	afx_msg void OnMatrixvsionMvbluefox1();
	afx_msg void OnCodeDansIm();
	afx_msg void OnUpdateCodeDansIm(CCmdUI* pCmdUI);
	afx_msg void OnGenCode();
	afx_msg void OnUpdateGenCode(CCmdUI* pCmdUI);
	afx_msg void OnUpdateDefCoul(CCmdUI* pCmdUI);
	afx_msg void OnDefCoul();
	afx_msg void OnLecteurleuzeConnecter();
	afx_msg void OnGenrerFais();
	afx_msg void OnLirecodes();
	afx_msg void OnUpdateLirecodes(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGenrerFais(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMatroxOrion(CCmdUI* pCmdUI);
	afx_msg void OnMatroxOrion();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
