// MatroxOrion.h : header file
//________________________________________
// CMatroxOrion window
#include "afxwin.h"
#include "mil.h"
#include "mwinmil.h"
#include "milsetup.h"
#include "milerr.h"
class CMatroxOrion : public CWnd
{
// Construction
public:
	CMatroxOrion();

// Attributes
public:
//Variables globales______________________
	long		SizeX;						// Buffer Size X
	long		SizeY;						// Buffer Size Y
	long		DigSizeX;					// Digitizer input width
	long		DigSizeY;					// Digitizer input heigh
	long		Band;				      // Number of input color bands of the digitizer
	CView   *GrabInViewPtr;		// Pointer to the view that has the grab
	long		NumberOfDigitizer;// Number of digitizers available on the system
  MIL_ID 	MilApplication;		// Application identifier.  
  MIL_ID 	MilSystem;     		// System identifier.       
	MIL_ID 	MilDigitizer;			// Digitizer identifier.
	MIL_ID MilImage;					//Image buffer identifier.
	MIL_ID MilDisplay;
	long BufferAttributes;		// Buffer attributes that will be allocated
	MAPPHOOKFCTPTR HandlerPtr;
	void* HandlerUserPtr;

//Prototypes______________________________
	long MFTYPE DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr);
	short TestOrion(void);
	short InitOrion(short *L,short *H);
	void LibereOrion(void);
	void RemoveFromDisplay(void);
	short AllocateDisplay(HWND hWnd);
	short AcqPermOrion(HWND hWnd);
	void FigerOrion(unsigned char *r,unsigned char *g,unsigned char *b);
	void GetPixelRouge(unsigned char *r);



// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMatroxOrion)
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CMatroxOrion();

	// Generated message map functions
protected:
	//{{AFX_MSG(CMatroxOrion)
		// NOTE - the ClassWizard will add and remove member functions here.
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//________________________________________
