// MeteorBk.cpp : implementation file
//________________________________________
#include "stdafx.h"
#include "Bk.h"
#include "MeteorBk.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CMeteorBk
CMeteorBk::CMeteorBk()
{
}
//________________________________________
CMeteorBk::~CMeteorBk()
{
}
//________________________________________
BEGIN_MESSAGE_MAP(CMeteorBk, CWnd)
	//{{AFX_MSG_MAP(CMeteorBk)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CMeteorBk message handlers
long MFTYPE CMeteorBk::DisplayError(long HookType, MIL_ID EventId, void MPTYPE *UserDataPtr)
{
	char 	ErrorMessageFunction[M_ERROR_MESSAGE_SIZE] = "";
	char 	ErrorMessage[M_ERROR_MESSAGE_SIZE]         = "";
	char 	ErrorSubMessage1[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage2[M_ERROR_MESSAGE_SIZE]     = "";
	char 	ErrorSubMessage3[M_ERROR_MESSAGE_SIZE]     = "";
	long 	NbSubCode;
	char	CErrorMessage[128];

	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_FCT,ErrorMessageFunction);
	MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT,ErrorMessage);
	MappGetHookInfo(EventId,M_CURRENT_SUB_NB,&NbSubCode);	
	if (NbSubCode > 2)
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_3,ErrorSubMessage3);	
	if (NbSubCode > 1)	
		MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_2,ErrorSubMessage2);
   if (NbSubCode > 0)
	   MappGetHookInfo(EventId,M_MESSAGE+M_CURRENT_SUB_1,ErrorSubMessage1);

	sprintf(CErrorMessage,"%s",ErrorMessageFunction);
	sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
	sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorMessage);
	if(NbSubCode > 0)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage1);
	}
	if(NbSubCode > 1)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage2);
	}
	if(NbSubCode > 2)
	{
		sprintf(CErrorMessage,"%s%s",CErrorMessage,"\n");
		sprintf(CErrorMessage,"%s%s",CErrorMessage,ErrorSubMessage3);
	}
	// Chain hook function
 	if(HandlerPtr)
 		(*HandlerPtr)(HookType,EventId,HandlerUserPtr);
	return M_NULL;
}

//________________________________________
short CMeteorBk::InitMeteor(short *L,short *H)
{
	short i;
	//Allocate an application
	MappAlloc(M_DEFAULT,&MilApplication);
	//Disable MIL error message to be displayed as the usual way
	MappControl(M_ERROR,M_PRINT_DISABLE);
	//Retrieve previous hanler ptr and user handler ptr
	MappInquire(M_CURRENT_ERROR_HANDLER_PTR,&HandlerPtr);		
	MappInquire(M_CURRENT_ERROR_HANDLER_USER_PTR,&HandlerUserPtr);	
	//Hook MIL error on function DisplayError()
	//MappHookFunction(M_ERROR_CURRENT,DisplayError,UserDataPtr);
	//Allocate a system	

	if (MsysAlloc(M_SYSTEM_METEOR_II,M_DEF_SYSTEM_NUM,M_COMPLETE,&MilSystem))
	{
		i=1;
		//Inquire number of digitizers available on the system
		MsysInquire(MilSystem,M_DIGITIZER_NUM,&NumberOfDigitizer);
		//Digitizer is available
		if (NumberOfDigitizer)	
		{
			//Allocate a digitizer
			MdigAlloc(MilSystem,M_DEFAULT,M_CAMERA_SETUP,M_DEFAULT,&MilDigitizer);
			//Stop live grab when window is disable
			MsysControl(MilSystem,M_STOP_LIVE_GRAB_WHEN_DISABLED,M_ENABLE);
			//Inquire digitizer informations
			MdigInquire(MilDigitizer,M_SIZE_X,&DigSizeX);
			MdigInquire(MilDigitizer,M_SIZE_Y,&DigSizeY);  	
			MdigInquire(MilDigitizer,M_SIZE_BAND,&Band);
			//Voir format d'acquisition CCIR par dfaut, fichier milsetup.h
			if (DigSizeX> M_DEF_IMAGE_SIZE_X_MAX) DigSizeX=M_DEF_IMAGE_SIZE_X_MAX;
			if (DigSizeY>M_DEF_IMAGE_SIZE_Y_MAX) 	DigSizeY=M_DEF_IMAGE_SIZE_Y_MAX;
			*H=DigSizeY;*L=DigSizeX;
		}
	}
	else
	{
		i=0;
		SizeX=M_DEF_IMAGE_SIZE_X_MIN;
		SizeY=M_DEF_IMAGE_SIZE_Y_MIN;
		Band=M_DEF_IMAGE_NUMBANDS_MIN;
	}
	if (i!=0)
	{
		//Carte prsente
		//Set SizeX and SizeY variables
		if(NumberOfDigitizer)
		{
			SizeX=DigSizeX;
			SizeY=DigSizeY;
		}
		//Allocate a buffer
		//Set buffer attributes
		if(NumberOfDigitizer)
			BufferAttributes=M_IMAGE+M_DISP+M_GRAB+M_PROC;
		else
			BufferAttributes=M_IMAGE+M_DISP+M_PROC;

		MbufAllocColor(MilSystem,Band,SizeX,SizeY,M_DEF_IMAGE_TYPE,BufferAttributes,&MilImage);
			//If not able to allocate a buffer, do not create a new document
		if(MilImage)
			//Clear the buffer 
			MbufClear(MilImage,0);
		else
		{
			*L=-1;
			*H=-1;
		}
	}
	else
	{
		//Carte Matrox non prsente
		*L=-1;
		*H=-1;
	}
	return i;
}
//________________________________________
short CMeteorBk::TestMeteor(void)
{
	short i;
	//Allocate an application
	MappAlloc(M_DEFAULT,&MilApplication);
	//Disable MIL error message to be displayed as the usual way
	MappControl(M_ERROR,M_PRINT_DISABLE);
	//Retrieve previous hanler ptr and user handler ptr
	MappInquire(M_CURRENT_ERROR_HANDLER_PTR,&HandlerPtr);		
	MappInquire(M_CURRENT_ERROR_HANDLER_USER_PTR,&HandlerUserPtr);	
	//Hook MIL error on function DisplayError()
	//MappHookFunction(M_ERROR_CURRENT,DisplayError,UserDataPtr);
	//Allocate a system	

	if (MsysAlloc(M_SYSTEM_METEOR_II,M_DEF_SYSTEM_NUM,M_COMPLETE,&MilSystem))
	{
		i=1;
		MsysFree(MilSystem);
	}
	else
	{
		i=0;
	}
	MappFree(MilApplication);
	return i;
}
//________________________________________
void CMeteorBk::LibereMeteor(void)
{
	MbufFree(MilImage);
	//if (MilDisplay) MdispFree(MilDisplay);

	/*if (MilDigitizer)*/ MdigFree(MilDigitizer);

	MsysFree(MilSystem);

	MappFree(MilApplication);
}