// SerieDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "SerieDlg.h"
#include "BkDoc.h"
#include "Leuze.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CSerieDlg dialog
CSerieDlg::CSerieDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerieDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSerieDlg)
	m_radioCom = -1;
	m_s = _T("");
	//}}AFX_DATA_INIT
}
void CSerieDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSerieDlg)
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDTEST, m_btnTest);
	DDX_Radio(pDX, IDC_COM1, m_radioCom);
	DDX_Text(pDX, IDC_STATIC_TEXTE, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSerieDlg, CDialog)
	//{{AFX_MSG_MAP(CSerieDlg)
	ON_BN_CLICKED(IDTEST, OnTest)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_COM1, OnCom1)
	ON_BN_CLICKED(IDC_COM2, OnCom2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CSerieDlg message handlers
BOOL CSerieDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd * pChild=((CMDIFrameWnd*) (AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_radioCom=m_pApp->m_radioCom;

	m_pLeuze=new CLeuze(m_radioCom);
	m_s.Format("Cliquer sur Tester pour demander la version de l'appareil...");
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CSerieDlg::OnTest() 
{
	UpdateData(TRUE);
	//Demande de la version de l'appareil
	m_pLeuze->WriteCom("V");
	m_btnTest.EnableWindow(FALSE);
	m_iNb=0;SetTimer(1,100,NULL);
}
//________________________________________
void CSerieDlg::OnCancel() 
{
	delete m_pLeuze;
	UpdateData(TRUE);
	m_pApp->m_radioCom=m_radioCom;
	CDialog::OnCancel();
}
//________________________________________
void CSerieDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	switch (nIDEvent)
	{
		case 1:
			//Demande de n de version
			m_iNb++;
			if (m_iNb>8)
			{
				KillTimer(1);
				m_btnTest.EnableWindow(TRUE);
				//On lit le buffer
				s=m_pLeuze->ReadBuf();
				if (s.IsEmpty())
				{
					m_s.Format("Erreur de lecture sur COM%d:9600,8,'N',1.",m_radioCom+1);
				}
				else
				{
					m_s.Format("Identification:\n%s",s);
					//m_pLeuze->VideBuffer();
				}
				UpdateData(FALSE);
			}
		break;
	}		
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CSerieDlg::OnCom1() 
{
	KillTimer(1);
	delete m_pLeuze;
	UpdateData(TRUE);
	m_pLeuze=new CLeuze(m_radioCom);
	SetTimer(1,100,NULL);
}
//________________________________________
void CSerieDlg::OnCom2() 
{
	KillTimer(1);
	delete m_pLeuze;
	UpdateData(TRUE);
	m_pLeuze=new CLeuze(m_radioCom);
	SetTimer(1,100,NULL);
}
