//WebCam.cpp : implementation file
//Voir Project/Settings/Link/Object-Library modules...
#include "stdafx.h"
#include "Bk.h"
#include <vfw.h>
#include "WebCam.h"
#include "BkDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CWebCam
CWebCam::CWebCam(short l,short h)
{
	//Taille de la fentre d'acquisition
	m_iL=l;m_iH=h;
}
//________________________________________
CWebCam::~CWebCam()
{
}
//________________________________________
BEGIN_MESSAGE_MAP(CWebCam, CWnd)
	//{{AFX_MSG_MAP(CWebCam)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CWebCam message handlers
BOOL CWebCam::Connexion(HWND	hWnd)
{
	return Connect(hWnd);
}
//________________________________________
BOOL CWebCam::Connect(HWND	hWnd)
{
	//Voir Project/Settings/Link/Object-Library modules...
	BOOL ok;
	//Connexion  la WebCam
	hWnd_WC=capCreateCaptureWindow("WebCam",WS_CHILD|WS_VISIBLE,0,0,m_iL,m_iH,hWnd,0) ;
	// Vrifie la connection
	if(!capDriverConnect(hWnd_WC,0))
	{
		//AfxMessageBox("Erreur de connexion  la Webcam !");
		ok=FALSE;
	}
	else
	{
		// Taille du preview = taille de la rsolution de la fentre
		capPreviewScale(hWnd_WC,TRUE) ;
		// Rafraichissement en ms
		capPreviewRate(hWnd_WC,15) ;
		ok=TRUE;
	}
	//DC 
	hDC_WC=::GetDC(hWnd_WC);
	//Connexion en cours
	m_OKConnect=ok;
	return ok;
}
//________________________________________
void CWebCam::AfficheWebCam()
{
	// Affiche
	capPreview(hWnd_WC,1) ;
}
//________________________________________
BOOL CWebCam::Deconnexion(unsigned char *R,unsigned char *G,unsigned char *B)
{
	//CString s;
	short 
		i,j,nbB,
		l,h;
	long w;
	BOOL okNB;
	//On copie dans tableaux
	okNB=TRUE;;
	for (i=0;i<m_iL;i++)
	{
		for (j=0;j<m_iH;j++)
		{
			w=::GetPixel(hDC_WC,i,j);
			R[i+j*m_iL]=w&255; 
			G[i+j*m_iL]=(w/256)&255; 
			B[i+j*m_iL]=(w/65536)&255;
			//Si toutes les composantes ne sont pas identiques, l'image est couleur
			if ((R[i+j*m_iL]!=B[i+j*m_iL]) || (R[i+j*m_iL]!=G[i+j*m_iL])) okNB=FALSE;
		}
	}
	capDriverDisconnect(hWnd_WC);

	//Il faut supprimer la fentre Webcam...
	//J'ai galr 2 jours avant de placer cette fonction !
	::DestroyWindow(hWnd_WC);

	m_OKConnect=FALSE;
	//Retourne TRUE pour une image nuance de gris
	return okNB;
}
//________________________________________
void CWebCam::DisConnect()
{
	capDriverDisconnect(hWnd_WC);
}
//________________________________________
void CWebCam::GrabStop()
{
	capGrabFrame(hWnd_WC);
}
//________________________________________
void CWebCam::GetPixelColor(short i,short j,unsigned char *R,unsigned char *G,unsigned char *B)
{
	long w;
	if (i>=0 && i<m_iL && j>=0 && j<m_iH)
	{
		w=::GetPixel(hDC_WC,i,j);
		*R=w&255; 
		*G=(w/256)&255; 
		*B=(w/65536)&255;
	}
	else
	{
		*R=0; 
		*G=0; 
		*B=0;
	}
}